@echo off
REM  ----------------------------------------------------------------------------------
REM                                  EpSilon.bat

REM  Creado  : 07/06/10 Manuel Parras.


REM  Proceso de arranque de proyecto fin de carrera EpSilon

REM  ----------------------------------------------------------------------------------

REM -----------------------------------------------------------------------------------
REM                     ELEMENTOS A CONFIGURAR EN LA INSTALACIN

REM Ruta absoluta del directorio 'EpSilon' que contiene la estructura de implantacin
REM (debe sustituirse por la especfica de la instalacin en el proyecto)
REM (Eliminar los espacios en blanco antes y tras la ruta)

    SET EPSILON_IMP=C:\EpSilon
    
REM Ejecucin en MODO DEPURACIN: en este caso aparecer una ventana donde se muestra
REM la carga de las clases necesarias para la ejecucin, las trazas generadas y las
REM excepciones internas producidas.
REM Valores: SI/NO (sin espacios en blanco) (Valor NO por defecto)

    SET DEBUG=NO    
    
REM Ejecucin de la aplicacin a partir de la estructura de clases comprimidas (fichero
REM 'EpSilon.jar') o descomprimidas (directorio 'es' obtenido del fichero anterior). Usar
REM estructura descomprimida por defecto, ya que de esta forma los ficheros de 
REM propiedades sern ms fcilmente accesibles.
REM Valores: SI/NO (sin espacios en blanco) (Valor NO por defecto)

    SET COMP=SI
    
REM  ----------------------------------------------------------------------------------


REM -----------------------------------------------------------------------------------
REM                      	VARIABLES INTERNAS USADAS 
REM Ruta de la estrutura de clases de la aplicacin, segn est o no comprimida

REM EPSILON=%EPSILON_IMP%\lib

SET EPSILON=C:\Util\Epsilon

IF  %COMP% == SI SET EPSILON=%EPSILON_IMP%\lib
FOR %%f IN (%EPSILON%\*.jar) DO CALL %EPSILON_IMP%\bin\add2path.bat "%%f" jar

REM Ruta de las clases externas necesarias para ejecucin

SET EXT=%EPSILON_IMP%\lib\ext

REM Ruta del comando java: Ruta donde tenemos la JDK de java
REM para poder compilar en la aplicacin.

SET JAVA=c:\progra~1\java\jdk1.6.0_10\bin

REM  ----------------------------------------------------------------------------------


REM Inclusin en las variables de entorno ZIP_PATH y JAR_PATH de los ficheros 
REM .zip y .jar contenidos en el directorio de clases externas necesarias para  
REM la ejecucin.

FOR %%f IN (%EXT%\*.jar) DO CALL %EPSILON_IMP%\bin\add2path.bat "%%f" jar
FOR %%f IN (%EXT%\*.zip) DO CALL %EPSILON_IMP%\bin\add2path.bat "%%f" zip


REM Lnea de arranque de la aplicacin.
REM Se accede al jre incluido dentro de la estructura de la aplicacin.

IF  NOT %DEBUG% == SI goto NORMAL:
IF  %DEBUG% == SI goto DEPURACION:

:NORMAL
start /min %JAVA%\javaw -Xbootclasspath/p:%EXT%\AbstractDocument.jar -classpath %EPSILON%;%JAR_PATH%;%ZIP_PATH%   proyecto.modulo.Principal %1 %2 %3 %4 %5 %6 %7 %8 %9
goto FIN:

:DEPURACION
start %JAVA%\java -Xbootclasspath/p:%EXT%\AbstractDocument.jar  -classpath %EPSILON%;%JAR_PATH%;%ZIP_PATH%   proyecto.modulo.Principal  %1 %2 %3 %4 %5 %6 %7 %8 %9
goto FIN:

:FIN

 
