/*
 * 
 * @author Manuel Parras  
 */

/**
 * JDialog:			AcercaDeVentana
 *
 */


// Paquete
// ---------------------------------------------------------------------------

package proyecto.acercade;

// Importaciones
// ---------------------------------------------------------------------------

import java.awt.*;

import javax.swing.*;

import proyecto.utilidades.OperacionesVentanas;




/** Clase que nos hace la apertura de la ventana de Acerca de. */
public class AcercaDeVentana extends JDialog 
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	AcercaDeControlador iadvControlador;
	Window  	    iwVentanaPadre;
 
    
    /**
	 * Constructor AcercaDeVentana.
	 * 
	 * @param awVentanaPadre
	 *            the aw ventana padre
	 * @param modal
	 *            the modal
	 */	
        
    public AcercaDeVentana(Window awVentanaPadre, boolean modal) 
    {
   
	iwVentanaPadre = awVentanaPadre;
	AcercaDePanel adp = new AcercaDePanel();
	
        // titulo de la ventana 
        this.setTitle("Acerca de...");
        
        // Aadimos el panel al centro del BorderLayout       
	getContentPane().add(adp, BorderLayout.CENTER );		

        setModal(modal);
        initComponents ();   
        
        pack ();
        	
        this.setBackground(java.awt.Color.white);
        setResizable(false);
 	// le damos un tamao a la ventana
	//this.setSize(500,383);
        this.setSize(525, 365);
        
        

    }

	/**
	 * Mtodo que nos abre la venta de acerca de
	 */
	public void abreVentana()
	{
				                        		
		OperacionesVentanas.centraVentana(iwVentanaPadre);
		Rectangle bounds = iwVentanaPadre.getBounds();
		Dimension size = getSize();
		setLocation(
				(int) (bounds.getX() + (bounds.getWidth() - size.getWidth()) / 2),
				(int) (bounds.getY() + (bounds.getHeight() - size.getHeight()) / 2));
		
		this.setVisible (true);   
	}


     /** Inicializacin del panel. Llamado desde el constructor
     *  NO MODIFICAR. Controlado por Forte
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
    }//GEN-END:initComponents

    /** Cierra el dilogo */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
	 * The main method.
	 * 
	 * @param args
	 *            Parametros de la linea de comandos
	 */ 
	 public static void main (String args[]) 
         {        
		
		AcercaDeVentana ladvAcercaDeVentana = new AcercaDeVentana (new JFrame (), true);                
                ladvAcercaDeVentana.abreVentana();
                      							                
          }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
