/*
 * 
 * @author Manuel Parras  
 */

package proyecto.arbol;
/*
 * MenuPopupArbol.java
 *
 * Created on 25 de abril de 2007, 9:29
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */



import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JTree;
import javax.swing.KeyStroke;
import javax.swing.text.BadLocationException;
import javax.swing.tree.DefaultMutableTreeNode;

import proyecto.editor.Editor;
import proyecto.paneles.VentanaEliminarProyecto;
import proyecto.utilidades.Mensajes;
import proyecto.utilidades.OperacionesFicheros;

/**
 * MenuPopupArbol.java
 * 
 * Esta clase es la encargada de pintarnos nuestro men contextual cuando
 * pulsemos con el botn derecho del ratn sobre un nodo de nuestro rbol. La
 * opciones que no despliegan dependern si pulsamos sobre un nodo carpeta o
 * fichero java o javaCC). Las opcin de carpeta es la ms completa para fichero
 * son menos opciones pero comparte opciones las siguientes :
 * <ul>
 * <li>tem Nuevo: nos despliega un submen con la opcin de crear (solo para
 * carpetas):
 * <ul>
 * <li>tem Carpeta: nueva carpeta en nuestro proyecto.
 * <li>tem java: nuevo fichero java en nuestro proyecto.
 * <li>tem JavaCC: nuevo fichero javaCC en nuestro proyecto.
 * </ul>
 * <li>tem Copiar: Almacenamos en memoria los seleccionado, si es carpeta todo
 * lo que contenga
 * <li>tem Cortar: Almacenamos en memoria el objeto seleccionado en el rbol
 * para su posterior movimiento
 * <li>tem Pegar: Insertar el elemento seleccionado en la posicin pulsada en
 * el rbol.
 * <li>tem Renombrar: Renombra el fichero seleccionad, verifica si es nombre
 * vlido,
 * <li>tem Suprimir: Elimina fsicamente el nodo seleccionado
 *	<li> tem Actualizar: Recarga nuestro rbol con los cambios realizados en nuestro espacio de trabajo
 * </ul>
 * Hay que tener en cuenta que hay que refrescar todas la referencias (paquete
 * activo, padre del nodo etc..) en la aplicacin cuando hacemos alguna opcin
 * que no est contemplada en la carga de la aplicacin, por ejemplo renombrar,
 * pegar .etc. (problema que me encontr y teniendo que reestructurar la
 * estructura).<br>.
 * 
 * Un tratamiento especial es para la carpeta raiz, ya que si la eliminamos estamos
 * eliminado el proyecto. <br>
 * 
 * Si deseamos ampliar con alguna opcin ms nuestro men contextual, debemos
 * definir el JMenuItem y en el mtodo getPopupMenu() se crear y se dir la
 * accin que debe realizar.
 * 
 * 
 * 
 * 
 * @author mparras
 */
public class MenuPopupArbol extends MouseAdapter {
    
    /** Opciones de nuestro menu contextual */
    private JMenuItem itemCopiarFichero,itemPegarCarpeta,itemRenombrarFichero,itemSuprCarpeta;
    
    /** Opciones de nuestro menu contextual. */
    private JMenuItem itemCortarFichero,itemSupr,itemRenombrarCarpeta,itemAbrirFichero;
    
    /** Manejador de nuestro menu contextua para carpetasl*/
    private JPopupMenu cachedMenuCarpeta = null;
    
    /**Manejador de nuestro menu contextual para la carpeta padre de nustro priyecto*/
    private JPopupMenu cachedMenuCarpetaRaiz = null;
    
    /**Manejador de nuestro menu contextual para nuestro ficheros */
    private JPopupMenu cachedMenuFichero = null;
    
    
    /** menuItemCarpeta menu para crear carpeta. */
    private JMenuItem menuItemCarpeta;
    
    /** menuItemJava menu para crear un fichero java */
    private JMenuItem menuItemJava;
    
    /**menuItemJavaCC men para crear un fichero javaCC */
    private JMenuItem menuItemJavaCC;
    
    /** Referencia de nuestro rboly tener referncia a l */
    private JTree tree;
    
    /**@see proyecto.arbol.ArbolFicheros  */
    private ArbolFicheros iArbol;
    
    /**actualiza nuestr rbol. */
    private JMenuItem itemActualizar;
	
	/** itemCopiarCarpeta copiar la carpeta seleccionada. */
	private JMenuItem itemCopiarCarpeta;
    
    
    
    
    
    
    
    
    /**
	 * Constructor MenuPopupArbol.
	 * 
	 * Creado : Parras, 18-abr-2009
	 * 
	 * @param aArbol
	 *            the a arbol
	 */
    public MenuPopupArbol(ArbolFicheros aArbol) {
        iArbol = aArbol;
        tree=iArbol.getTree();
        
    }
    
    
    
    
    /* (non-Javadoc)
     * @see java.awt.event.MouseAdapter#mousePressed(java.awt.event.MouseEvent)
     */
    public void mousePressed(MouseEvent ev) {
    	if (ev.getButton()==MouseEvent.BUTTON3){
	        if (!tree.isSelectionEmpty()){
	            DefaultMutableTreeNode nodo = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
	            //System.out.println(nodo);
	            
	            if (((Nodo) nodo.getUserObject()).getDirectorioOk()){
	                //activarPopupFichero(ev);
	            	if (!nodo.isRoot())
	            		activarPopupCarpeta(ev);
	            	else
	            		activarPopupCarpetaRaiz(ev);
	            }else if (!((Nodo) nodo.getUserObject()).getDirectorioOk())
	                activarPopupFichero(ev);
	        }
    	}
        
    }
    
    
    /* (non-Javadoc)
     * @see java.awt.event.MouseAdapter#mouseReleased(java.awt.event.MouseEvent)
     */
    public void mouseReleased(MouseEvent ev) {
    	if (ev.getButton()==MouseEvent.BUTTON3){
	        if (!tree.isSelectionEmpty()){
	            DefaultMutableTreeNode nodo = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
	            //System.out.println(nodo);
	            if (((Nodo) nodo.getUserObject()).getDirectorioOk()){
	            	if (!nodo.isRoot())
	            		activarPopupCarpeta(ev);
	            	else
	            		activarPopupCarpetaRaiz(ev);
	                
	            }else if (!((Nodo) nodo.getUserObject()).getDirectorioOk())
	                activarPopupFichero(ev);
	        }
    	}
        
    }
   
   




		/* (non-Javadoc)
		 * @see java.awt.event.MouseAdapter#mouseClicked(java.awt.event.MouseEvent)
		 */
		public void mouseClicked(MouseEvent ev) {
        	
            if (ev.getClickCount()==2){
            	
            	
            	iArbol.abrirFichero ();
                
                
            }
            //System.out.print(ev.getButton()+"  "+MouseEvent.BUTTON2);
            if (ev.getButton()==MouseEvent.BUTTON3){
            	
	            if (!tree.isSelectionEmpty()){
	                DefaultMutableTreeNode nodo = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
	                
	                if (((Nodo) nodo.getUserObject()).getDirectorioOk()){
	                	if (!nodo.isRoot())
	                		activarPopupCarpeta(ev);
	                	else
	                		activarPopupCarpetaRaiz(ev);
	                }else if (!((Nodo) nodo.getUserObject()).getDirectorioOk())
	                    activarPopupFichero(ev);
	            }
            }
            
        }
        //Activa el Menu de para nuestras carpetas en el rbol
        /**
		 * Activa el Menu de para nuestras carpetas en el rbol. <br>
		 * Creado : Parras, 18-abr-2009
		 * 
		 * @param ev Evento del raton para obtener sus coordenadas
		 *            
		 */
        private void activarPopupCarpeta(MouseEvent ev) {
            
            if (ev.isPopupTrigger()) {
                
                
                JPopupMenu menu = getPopupMenuCarpeta();
                
                
                menu.pack();
                menu.show((Component)ev.getSource(), ev.getX(), ev.getY());
                
                
            }
        }
        //Activa el Menu de para nuestra carpeta raiz que es el nombre del proyecto
        // la cual tendra un tratamiento diferente
        /**
		 * Activa el Menu de para nuestra carpeta raiz que es el nombre del proyecto
         * la cual tendra un tratamiento diferente 
		 * 
		 * <br>Creado : Parras, 18-abr-2009
		 * 
		 * @param ev Evento del raton para obtener sus coordenadas
		 */
        private void activarPopupCarpetaRaiz(MouseEvent ev) {
            
            if (ev.isPopupTrigger()) {
                
                
                JPopupMenu menu = getPopupMenuCarpetaRaiz();
                
                
                menu.pack();
                menu.show((Component)ev.getSource(), ev.getX(), ev.getY());
                
                
            }
        }
        //Activa el Menu de para nuestras ficheros en el rbol
        /**
		 * Activa el Menu de para nuestras ficheros en el rbol 
		 * <br> Creado : Parras, 18-abr-2009
		 * 
		 * @param ev Evento del raton para obtener sus coordenadas
		 */
        private void activarPopupFichero(MouseEvent ev) {
            
            if (ev.isPopupTrigger()) {
                
                
                JPopupMenu menu = getPopupMenuFichero();
                
                
                menu.pack();
                menu.show((Component)ev.getSource(), ev.getX(), ev.getY());
                
                
            }
            
            
        }
        
        
        /**
		 * getPopupMenuFichero Genera los item necesarios para nuestro menu de
		 * fichero.
		 * 
		 * @return the popup menu fichero
		 */
        private JPopupMenu getPopupMenuFichero() {
            //A un fichero lo que le podemos hacer al menu Popup copiar,cortar,renombrar,actualizar
            
            JPopupMenu menu = cachedMenuFichero;
            if (menu==null){
                menu = new JPopupMenu();
                //TEM Abrir
                itemAbrirFichero = new JMenuItem("Abrir");
                itemAbrirFichero.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    	iArbol.abrirFichero (); 
                    }
                });
                menu.add(itemAbrirFichero);
                menu.addSeparator();
                //	ITEM COPIAR ctrl+C
                itemCopiarFichero = new JMenuItem("Copiar");
                itemCopiarFichero.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
                itemCopiarFichero.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.copiarFichero();
                        if (itemPegarCarpeta!=null)
                            itemPegarCarpeta.setEnabled(true);
                        else{
                            itemPegarCarpeta = new JMenuItem("Pegar");
                            itemPegarCarpeta.setEnabled(true);
                        }
                    }
                });
                
                
                menu.add(itemCopiarFichero);
                
                
                //	ITEM Cortar  ctrl+x
                itemCortarFichero = new JMenuItem("Cortar");
                itemCortarFichero.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
                itemCortarFichero.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.cortarFcihero();
                        if (itemPegarCarpeta!=null)
                            itemPegarCarpeta.setEnabled(true);
                        else{
                            itemPegarCarpeta = new JMenuItem("Pegar");
                            itemPegarCarpeta.setEnabled(true);
                        }  
                    }
                });
                
                menu.add(itemCortarFichero);
                menu.addSeparator();
                //	ITEM Renombrar
                itemRenombrarFichero = new JMenuItem("Renombrar");
                itemRenombrarFichero.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.renombrarPath();
                    }
                });
                
                menu.add(itemRenombrarFichero);
                
                //	ITEM Suprimir SUPR
                itemSupr = new JMenuItem("Suprimir");
                itemSupr.setMnemonic('l');
                itemSupr.setDisplayedMnemonicIndex(2);
                itemSupr.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
                itemSupr.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.eliminarPath();
                    }
                });
                
                menu.add(itemSupr);
            }
            cachedMenuFichero=menu ;
            return menu;
        }
       
        /**
		 * getPopupMenuCarpeta Genera los item necesarios para nuestro menu de
		 * carpeta, con la salvedad de nueestro nodo raiz que sera nuestro caso
		 * especial.
		 * 
		 * @return the popup menu carpeta
		 */
        private JPopupMenu getPopupMenuCarpeta() {
            
            //A este Popup le pondremos SubMenu para crear (Carpeta,Java,JJ), Reombrar, Pegar,Actualizar
            JPopupMenu menu = cachedMenuCarpeta;
            
            if (menu == null) {
                
                menu = new JPopupMenu();
                
                
                JMenu   submenu = new JMenu("Nuevo");
                //submenu.setMnemonic(KeyEvent.VK_S);
                
                menuItemCarpeta = new JMenuItem("Carpeta");
                menuItemCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        String nombre = JOptionPane.showInputDialog("Nombre de la carpeta");
                        if (nombre!=null){
                        if (OperacionesFicheros.validadorFileName(nombre))                        
                        	iArbol.setCarpeta(nombre);
                        else
                        	Mensajes.mensajeAtencion("Nombre del la carpeta no valido");
                        }
                    }
                    
                });
                submenu.add(menuItemCarpeta);
                
                submenu.addSeparator();
                menuItemJava = new JMenuItem("Fichero Java");
                menuItemJava.setAccelerator(KeyStroke.getKeyStroke(
                 KeyEvent.VK_J, ActionEvent.ALT_MASK));
                menuItemJava.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        String nombre = JOptionPane.showInputDialog("Nombre Fichero Java");
                        if (nombre!=null){
                        if (OperacionesFicheros.validadorFileName(nombre))                        
                        	iArbol.setFichero(nombre +".java");
                        else
                        	Mensajes.mensajeAtencion("Nombre del fichero no valido");
                        }
                    }
                    
                });
                submenu.add(menuItemJava);
                
                
                menuItemJavaCC = new JMenuItem("Fichero JavaCC");
                menuItemJavaCC.setAccelerator(KeyStroke.getKeyStroke(
                 KeyEvent.VK_C, ActionEvent.ALT_MASK));
                menuItemJavaCC.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        String nombre = JOptionPane.showInputDialog("Nombre Fichero JavaCC");
                        if (nombre!=null){
                        if ( OperacionesFicheros.validadorFileName(nombre))                        
                        	iArbol.setFichero(nombre +".jj");
                        else
                        	Mensajes.mensajeAtencion("Nombre del fichero no valido");
                        }
                    }
                    
                });
                submenu.add(menuItemJavaCC);
                menu.add(submenu);
                
                menu.addSeparator();
                
                  //	ITEM COPIAR ctrl+C
                itemCopiarCarpeta = new JMenuItem("Copiar");
                itemCopiarCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
                itemCopiarCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.copiarCarpeta();
                        if (itemPegarCarpeta!=null)
                            itemPegarCarpeta.setEnabled(true);
                        else{
                            itemPegarCarpeta = new JMenuItem("Pegar");
                            itemPegarCarpeta.setEnabled(true);
                        }
                    }
                });
                
                
                menu.add(itemCopiarCarpeta);
                
                //	ITEM Pegar ctrl+V
                if (itemPegarCarpeta==null){
                    itemPegarCarpeta = new JMenuItem("Pegar");
                    itemPegarCarpeta.setEnabled(false);
                }
                
                itemPegarCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, ActionEvent.CTRL_MASK));
                itemPegarCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        try {
                            iArbol.pegarFichero();
                            
                        } catch (IOException ex) {
                            ex.printStackTrace();
                        }
                        itemPegarCarpeta.setEnabled(false);
                    }
                    
                });
                
                menu.add(itemPegarCarpeta);
                
                //	ITEM Renombrar
                itemRenombrarCarpeta = new JMenuItem("Renombrar");
                itemRenombrarCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.renombrarPath();
                    }
                });
                
                menu.add(itemRenombrarCarpeta);
                
                menu.addSeparator();
                 //	ITEM Suprimir SUPR
                itemSuprCarpeta = new JMenuItem("Suprimir");
                itemSuprCarpeta.setMnemonic('l');
                itemSuprCarpeta.setDisplayedMnemonicIndex(2);
                itemSuprCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
                itemSuprCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.eliminarPath();
                    }
                });
                
                menu.add(itemSuprCarpeta);
                
                
                
                //	ITEM Actualiza F5
                itemActualizar = new JMenuItem("Actualizar");
                itemActualizar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
                itemActualizar.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.refrescarArbol();
                    }
                });
                
                menu.add(itemActualizar);
                
            }
            cachedMenuCarpeta=menu ;
            return menu;
            
        }
        //Genera item para nuestro nodo Raiz
        /**
		 * Obtener el popup menu carpeta raiz.
		 * 
		 * @return el popup menu carpeta raiz Creado : Parras, 18-abr-2009
		 */
        private JPopupMenu getPopupMenuCarpetaRaiz() {
            
            //A este Popup le pondremos SubMenu para crear (Carpeta,Java,JJ), Reombrar, Pegar,Actualizar
            JPopupMenu menu = cachedMenuCarpetaRaiz;
            
            if (menu == null) {
                
                menu = new JPopupMenu();
                
                
                JMenu   submenu = new JMenu("Nuevo");
                //submenu.setMnemonic(KeyEvent.VK_S);
                
                menuItemCarpeta = new JMenuItem("Carpeta");
                menuItemCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        String nombre = JOptionPane.showInputDialog("Nombre de la carpeta");
                        if (nombre!=null){
                        if (nombre!=null && OperacionesFicheros.validadorFileName(nombre))                        
                        	iArbol.setCarpeta(nombre);
                        else
                        	Mensajes.mensajeAtencion("Nombre del la carpeta no valido");
                        }
                    }
                    
                });
                submenu.add(menuItemCarpeta);
                
                submenu.addSeparator();
                menuItemJava = new JMenuItem("Fichero Java");
                menuItemJava.setAccelerator(KeyStroke.getKeyStroke(
                 KeyEvent.VK_J, ActionEvent.ALT_MASK));
                menuItemJava.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        String nombre = JOptionPane.showInputDialog("Nombre Fichero Java");
                        if (nombre!=null){
                        if (nombre!=null && OperacionesFicheros.validadorFileName(nombre))                        
                        	iArbol.setFichero(nombre +".java");
                        else
                        	Mensajes.mensajeAtencion("Nombre del fichero no valido");
                        }
                    }
                    
                });
                submenu.add(menuItemJava);
                
                
                menuItemJavaCC = new JMenuItem("Fichero JavaCC");
                menuItemJavaCC.setAccelerator(KeyStroke.getKeyStroke(
                 KeyEvent.VK_C, ActionEvent.ALT_MASK));
                menuItemJavaCC.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    	String nombre = JOptionPane.showInputDialog("Nombre Fichero Java");
                    	if (nombre!=null){
                    		if (nombre!=null && OperacionesFicheros.validadorFileName(nombre))                        
                    			iArbol.setFichero(nombre +".jj");
                    		else{
                    			Mensajes.mensajeAtencion("Nombre del fichero no valido");                   
                    			
                    		}

                    	}
                    }

                });
                submenu.add(menuItemJavaCC);
                menu.add(submenu);
                
                menu.addSeparator();
                
//                  //	ITEM COPIAR ctrl+C
//                itemCopiarCarpeta = new JMenuItem("Copiar");
//                itemCopiarCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
//                itemCopiarCarpeta.addActionListener(
//                 new ActionListener() {
//                    public void actionPerformed(ActionEvent e) {
//                        iArbol.copiarCarpeta();
//                        if (itemPegarCarpeta!=null)
//                            itemPegarCarpeta.setEnabled(true);
//                        else{
//                            itemPegarCarpeta = new JMenuItem("Pegar");
//                            itemPegarCarpeta.setEnabled(true);
//                        }
//                    }
//                });
//                
//                
//                menu.add(itemCopiarCarpeta);
                
                //	ITEM Pegar ctrl+V
                if (itemPegarCarpeta==null){
                    itemPegarCarpeta = new JMenuItem("Pegar");
                    itemPegarCarpeta.setEnabled(false);
                }
                
                itemPegarCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, ActionEvent.CTRL_MASK));
                itemPegarCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        try {
                            iArbol.pegarFichero();
                            
                        } catch (IOException ex) {
                            ex.printStackTrace();
                        }
                        itemPegarCarpeta.setEnabled(false);
                    }
                    
                });
                
                menu.add(itemPegarCarpeta);
                
                //	ITEM Renombrar
                itemRenombrarCarpeta = new JMenuItem("Renombrar");
                itemRenombrarCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    	//debemos renombrar nuestra variable con los datos de los proyectos
                    	//System.out.print("Hacer renombrar  nodo principal");
                    	iArbol.renombrarPath();
                    }
                });
                
                menu.add(itemRenombrarCarpeta);
                
                menu.addSeparator();
                 //	ITEM Suprimir SUPR
                itemSuprCarpeta = new JMenuItem("Suprimir");
                itemSuprCarpeta.setMnemonic('l');
                itemSuprCarpeta.setDisplayedMnemonicIndex(2);
                itemSuprCarpeta.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
                itemSuprCarpeta.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        System.out.print("Hacer suprimir nodo principal");
            			VentanaEliminarProyecto ventanaElimina=new VentanaEliminarProyecto(Editor.get(),true);
            			ventanaElimina.setVisible(true);
                    }
                });
                
                menu.add(itemSuprCarpeta);
                
                
                
                //	ITEM Actualiza F5
                itemActualizar = new JMenuItem("Actualizar");
                itemActualizar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
                itemActualizar.addActionListener(
                 new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        iArbol.refrescarArbol();
                    }
                });
                
                menu.add(itemActualizar);
                
            }
            cachedMenuCarpetaRaiz=menu ;
            return menu;
            
        }




	
        
        
    }

