/**
 * Clase:			Etiqueta
 *
 * Creaci�n: 29 de junio de 2001, 11:41, jmorenom	RFC:
 * Revisi�n: 29 de junio de 2001, 11:41, jmorenom	RFC:
 */


// Paquete
// ---------------------------------------------------------------------------
package proyecto.configuracion.multilenguaje;


// Importaciones
// ---------------------------------------------------------------------------



/** Descripci�n: Etiqueta (nombre, tecla_rapida) */

public class Etiqueta extends java.lang.Object {

	private String isNombre;
	private char icTeclaRapida;

	/** Constructor Etiqueta */
    public Etiqueta(String asNombre,char acTecla) {

		isNombre = asNombre;
		icTeclaRapida = acTecla;
    }

	/** Construye una etiqueta en base a una cadena <nombre>&<tecla> */
	public Etiqueta(String asNombreTecla)
	{
		if (asNombreTecla != null)
		{
			// Posicion del Ampersand (&)
			int liPosAmper = asNombreTecla.indexOf('&');

			// Obtenemos el nombre
			if (liPosAmper > -1)
			{
				isNombre = asNombreTecla.substring(0, liPosAmper);
			}
			else
			{
				isNombre = asNombreTecla;
			}

			// Obtenemos la tecla

			if (liPosAmper > -1)
			{
				icTeclaRapida = asNombreTecla.charAt(liPosAmper + 1);
			}

		}
	}

	public String getNombre()
	{
		return isNombre;
	}

	public char getTeclaRapida()
	{
		return icTeclaRapida;
	}

	public void setNombre(String asNombre)
	{
		isNombre = asNombre;
	}

	public void setTeclaRapida(char acTecla)
	{
		icTeclaRapida = acTecla;
	}

	@SuppressWarnings("unused")
	private static void main (String args[]) {
		try{

			Etiqueta e = new Etiqueta("Aceptar&A");
			Etiqueta e2 = new Etiqueta("Aceptar");
			Etiqueta e3 = new Etiqueta("&A");
			Etiqueta e4 = new Etiqueta("");
			Etiqueta e5 = new Etiqueta(null);
			Etiqueta e6 = new Etiqueta("Prueba&PP");

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("Aceptar&A");
			System.out.println(e.getNombre());
			System.out.println(e.getTeclaRapida());

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("Aceptar");
			System.out.println(e2.getNombre());
			System.out.println(e2.getTeclaRapida());

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("&A");
			System.out.println(e3.getNombre());
			System.out.println(e3.getTeclaRapida());

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("");
			System.out.println(e4.getNombre());
			System.out.println(e4.getTeclaRapida());

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("null");
			System.out.println(e5.getNombre());
			System.out.println(e5.getTeclaRapida());

			System.out.println("NOMBRE ORIGINAL: ");
			System.out.println("Prueba&PP");
			System.out.println(e6.getNombre());
			System.out.println(e6.getTeclaRapida());

		}
		catch (Exception e)
		{
			e.printStackTrace();
			System.exit(0);
		}


	}


}


