/*
 * 
 * @author Manuel Parras  
 */
package proyecto.consola;


import java.io.File;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import org.jvnet.substance.SubstanceLookAndFeel;
import proyecto.imagenes.IconFactory;






/**
 * <p>
 * TabbInformacion
 * </p>
 * <p>
 * Clase contenedora del ConsolaTextPane, para poder representar varios en un
 * mismo panel.
 * </p>
 * <p>
 * Esta clase se sita en el panel principal de la aplicacin al tener un
 * Borderlayout, la ubicamos en el sur.
 * </p>
 * 
 * @see proyecto.consola.ConsolaTextPane
 * @see java.awt.BorderLayout
 */
public class TabbInformacion extends JTabbedPane {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	//private ConsolaTextPane panelConsola = new ConsolaTextPane ();
	
	/**
	 * Constructor tabb informacion.
	 * 
	 * Creado : Parras, 24-jun-2009
	 */
	public TabbInformacion(){
		super(JTabbedPane.BOTTOM);
		
		//this.addTab("Consola",ConsolePane.getInstance());
		this.putClientProperty(
				SubstanceLookAndFeel.TABBED_PANE_CLOSE_BUTTONS_PROPERTY,
				Boolean.TRUE);
		
		//this.addTab("Consola",IconFactory.getImage("consola.gif"),new JScrollPane (panelConsola,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS));
		//this.addTab("Problemas",IconFactory.getImage("problemas_consola.gif"),new JTable());
	}
	
	/**
	 * Crea un nuevo Tab sobre consola.
	 * 
	 * @param fichero
	 *            the fichero
	 * 
	 * @return ConsolaTextPane
	 * @see proyecto.consola.ConsolaTextPane
	 */
	public ConsolaTextPane addTabConsola(File fichero){
		ConsolaTextPane lpanelConsola = new ConsolaTextPane ();
		this.addTab(fichero.getName(),IconFactory.getImage("consola.gif"),new JScrollPane (lpanelConsola,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS));		
		this.setSelectedIndex(this.getTabCount()-1);
		return lpanelConsola;
	}
	
	/**
	 * Crea un nuevo Tab sobre consola con una consolaTextPane pasada como
	 * parametro.
	 * 
	 * @param aPanelConsola
	 *            ConsolaTextPane
	 * @param fichero
	 *            File
	 *            @see proyecto.consola.ConsolaTextPane
	 */
	public void addTabConsola(ConsolaTextPane  aPanelConsola,File fichero){
		
		this.addTab(fichero.getName(),IconFactory.getImage("consola.gif"),new JScrollPane (aPanelConsola,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS));
		this.setSelectedIndex(this.getTabCount()-1);
		this.setToolTipTextAt(this.getSelectedIndex(), fichero.toString());
		
	}


//	public ConsolaTextPane getPanelConsola() {
//		panelConsola.setText("");
//		return panelConsola;
//	}
//
//	public void setPanelConsola(ConsolaTextPane panelConsola) {
//		this.panelConsola = panelConsola;
//	}
	
//	public void recargarConsola(){
//		String texto = panelConsola.getText();
//		panelConsola.setText("");
//		panelConsola.setContentType("text/html");
//		panelConsola.setText(texto);
//	}
	


}
