/*
 * 
 * @author Manuel Parras  
 */
package proyecto.herramientas;

import java.beans.XMLEncoder;
import java.io.BufferedOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import org.apache.log4j.Logger;

import proyecto.editor.Editor;




/**
 * PreferenciasUsuario.
 * 
 * <p> Objeto donde se definirn las propiedadades del usuario para el IDE.</p>
 * <p> Este objeto se guardar en la carpeta de configuracin en nuestro IDE con el nombre prefUsu.xml</p>
 * 
 */
public class PreferenciasUsuario {

	/** Constant objLogger. */
	private static final Logger objLogger = Logger.getLogger(PreferenciasUsuario.class);
	
	/** guardar al compilar. */
	private boolean ibGuardarAlCompilar;
	
	/** salir de la aplicacin si confrmacion del usuario, en el caso que no exista cosas pendienderconfirmar. */
	private boolean ibsalirConfirmar;
	
	
	/**
	 * Constructor preferencias usuario.
	 * 
	 * Creado : Parras, 25-nov-2009
	 */
	public PreferenciasUsuario(){
		ibGuardarAlCompilar = true;
		ibsalirConfirmar = false;
				
	}
	
	/**
	 * Constructor preferencias usuario.
	 * 
	 * Creado : Parras, 25-nov-2009
	 * 
	 * @param abGuardarAlCompilar
	 *            the ab guardar al compilar
	 * @param absalirConfirmar
	 *            the absalir confirmar
	 */
	public PreferenciasUsuario(boolean abGuardarAlCompilar, boolean absalirConfirmar){
		ibGuardarAlCompilar = abGuardarAlCompilar;
		ibsalirConfirmar = absalirConfirmar;
		
	}
	
	/**
	 * Modificar la propiedad salir confirmar.
	 * <p>salir de la aplicacin si confrmacion del usuario, en el caso que no exista cosas pendienderconfirmar.</p>
	 * @param salirConfirmar
	 *            La propiedad salir confirmar
	 */
	public void setSalirConfirmar(boolean salirConfirmar) {
		this.ibsalirConfirmar = salirConfirmar;
	}
	
	/**
	 * Verificamos si es salir confirmar.
	 * <p>salir de la aplicacin si confrmacion del usuario, en el caso que no exista cosas pendienderconfirmar.</p>
	 * @return true, Si es salir confirmar Creado : Parras, 25-nov-2009
	 */
	public boolean isSalirConfirmar() {
		return ibsalirConfirmar;
	}
	
	/**
	 * Verificamos si es guardar al compilar.
	 * 
	 * @return true, Si es guardar al compilar Creado : Parras, 25-nov-2009
	 */
	public boolean isGuardarAlCompilar() {
		return ibGuardarAlCompilar;
	}
	
	/**
	 * Modificar la propiedad guardar al compilar.
	 * 
	 * @param guardarAlCompilar
	 *            La propiedad guardar al compilar
	 */
	public void setGuardarAlCompilar(boolean guardarAlCompilar) {
		this.ibGuardarAlCompilar = guardarAlCompilar;
	}
	
	public void guardarObjetoAFichero(){
		 XMLEncoder e;
			try {
				e = new XMLEncoder(new BufferedOutputStream(new FileOutputStream(Editor.get().getPrefUsuerXML())));
				e.writeObject(this);
		        e.close();
			} catch (FileNotFoundException e1) {
				if (objLogger.isDebugEnabled())
					objLogger.debug("Error en nuestro fichero  prefUsu.xml" + e1);
			}
	}
	
	public String toString(){
		return "Valor => ibGuardarAlCompilar " + ibGuardarAlCompilar + " ibsalirConfirmar " + ibsalirConfirmar;
	}
}
