/*
 * 
 * @author Manuel Parras  
 */


package proyecto.impresion;


import java.util.ArrayList;
import java.util.Properties;

import javax.swing.text.Document;

import proyecto.paneles.DatosExportar;



/**
 *  ImprimirEpsilonControlador.
 *  <p> Esta clase es la encargada de controlar y aadir clases a nuestro Reporte</p>
 */
public class ImprimirEpsilonControlador{
    
    /** parametros. */
    private Properties parametros;
    
    /**  nombre. */
    private ArrayList laNombre;
    
    /**  valor. */
    private ArrayList laValor;
    
    /**  report data maestro. */
    private ArrayList aoReportDataMaestro;
    
    /**  path maestro. */
    private String sPathMaestro;
    
    /**  vista. */
    private ImprimirEpsilon iVista;
       
    /**
	 * Nueva Instancia IncidenciasPanelControlador.
	 * 
	 * @param aVista
	 *             vista
	 */
    public ImprimirEpsilonControlador(ImprimirEpsilon aVista) {                 
         parametros = new Properties();
         laNombre = new ArrayList();
         laValor = new ArrayList();       
         aoReportDataMaestro = new ArrayList();
         sPathMaestro = "";
         iVista = aVista;
         
    }

    /**
	 * Aade parmetros al report maestro. el report maestro tambien puede
	 * pasarle parmetros a subReports
	 * 
	 * @param nombre
	 *            nombre
	 * @param valor
	 *            valor
	 */
    public void addParametro(String nombre, String valor){
    	if(valor == null || valor == "") valor = " ";
            parametros.put(nombre, valor);
        }
    
    /**
	 * Aade parametro. Creado : Parras, 08-nov-2009
	 * 
	 * @param nombre
	 *            nombre
	 * @param valor
	 *            valor
	 */
    public void addParametro(String nombre, Document valor){
            parametros.put(nombre, valor);
        }
     
     /**
		 * Aade un DataSource para un subReport, a diferencia de
		 * setReportDataSource aqui hay que darle un nombre al parmetro que va
		 * a contenerlo. la longitud de la lista ser el numero de filas que
		 * contenga.
		 * 
		 * Debern crear un parametro en el report maestro de tipo
		 * 'net.sf.jasperreports.engine.JRDataSource'. y este se lo deber pasar
		 * al subreport. use datasource expreasion: P{nombre_del_parametro}
		 * 
		 * @param nombre
		 *            nombre
		 * @param valor
		 *            valor
		 */
    public void addSubreportDataSource(String nombre, ArrayList valor){
        laNombre.add(nombre);
        laValor.add((Object[])valor.toArray(new Object[valor.size()]));
    }
    
     /**
		 * Aade el DataSource principal para el report. la longitud de la lista
		 * sern el numero de filas que contenga. el nombre del parmetro con el
		 * que se envie ser 'REPORT_DATA_SOURCE'
		 * 
		 * @param alDataSource
		 *            al data source
		 */
    public void setReportDataSource(ArrayList alDataSource){
        aoReportDataMaestro = new ArrayList(alDataSource);
    }
    
    /**
	 * Recopila toda la informacin y la envia para imprimir.
	 */
    public void imprimir(){
              
       if(aoReportDataMaestro.isEmpty()){
            aoReportDataMaestro.add(null);
        }
        
        	iVista.informe.setParametros(parametros);
        	
        	//iVista.informe.setParametrosSubreport((String[])laNombre.toArray(new String[laNombre.size()]),(Object[])laValor.toArray(new Object[laValor.size()]));
        	iVista.informe.setInforme("/proyecto/informe/epsilon.jasper");
        	
        	iVista.informe.cargaDatos((Object[])aoReportDataMaestro.toArray(new Object[aoReportDataMaestro.size()]));
        	//iVista.informe.cargaDatos();
        	
        	iVista.informe.imprime();
    }
    
     /**
		 * Imprimir. Creado : Parras, 08-nov-2009
		 * 
		 * @param datos
		 *            datos
		 */
     public void imprimir(DatosExportar datos){
              
       if(aoReportDataMaestro.isEmpty()){
            aoReportDataMaestro.add(null);
        }
        
        	iVista.informe.setParametros(parametros);
        	
        	//iVista.informe.setParametrosSubreport((String[])laNombre.toArray(new String[laNombre.size()]),(Object[])laValor.toArray(new Object[laValor.size()]));
        	iVista.informe.setInforme("/proyecto/informe/epsilon.jasper");
        	
        	iVista.informe.cargaDatos((Object[])aoReportDataMaestro.toArray(new Object[aoReportDataMaestro.size()]));
        	//iVista.informe.cargaDatos();
        	
        	iVista.informe.imprime(datos);
    }

    /**
	 * Seleccionamos la ruta donde se encuentra el report que sera impreso.
	 * 
	 * @param asPath
	 *            as path
	 */
    public void setPathMaestro(String asPath){
        //sPathMaestro = asPath;
    }
    
    /**
	 * Inicializa. Creado : Parras, 08-nov-2009
	 * 
	 * @param aoArgs
	 *            ao args
	 */
    public void inicializa(Object[] aoArgs) {
    }
    
    /**
	 * Guardar. Creado : Parras, 08-nov-2009
	 * 
	 * @throws Exception
	 *             exception
	 */
    public void guardar() throws Exception {
    }
    
}
