/*
 * 
 * @author Manuel Parras  
 */

package proyecto.paneles;


import java.awt.Component;
import java.io.File;


import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import java.io.FileFilter;
import java.util.ArrayList;
import java.util.Arrays;

import proyecto.arbol.PaqueteActivos;
import proyecto.editor.Editor;
import proyecto.imagenes.IconFactory;
import proyecto.utilidades.OperacionesVentanas;


/**
 * SeleccionPaqueteDialogo
 * <p> Buscamos los nuevos Proyectos que pertenecen a nuestro workSpace. 
 * 
 * @see proyecto.paneles.NuevoVentana
 * @see proyecto.editor.ControlVentEditor
 * @see proyecto.arbol.PaqueteActivos
 * @see javax.swing.JDialog
 * @author Parras
 */
public class SeleccionNProyectosDialogo extends javax.swing.JDialog {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 206045939584249440L;


	/** proyecto files. */
	File[] iProyectoFile;

	/** The proyecto selecionado. */
	File iProyectoSelecionado;

	

	

	public SeleccionNProyectosDialogo(SeleccionPaqueteDialogo seleccionPaqueteDialogo, boolean modal,File[] aProyectoFile) {
		
		super(seleccionPaqueteDialogo, modal);

		iProyectoFile = aProyectoFile;
		initComponents();		
		jButtonAceptar.setEnabled(false);
		jButtonAceptar.setMnemonic('A');
		jButtonCancelar.setMnemonic('C');		
		OperacionesVentanas.centraVentanaHija(this);
		setTitle("Cargar Proyeto");
		this.pack();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed"
	// desc=" Generated Code ">//GEN-BEGIN:initComponents
	private void initComponents() {
		java.awt.GridBagConstraints gridBagConstraints;

		jPanel2 = new javax.swing.JPanel();
		jScrollPane1 = new javax.swing.JScrollPane();
		jListListaPaquetes = new javax.swing.JList();
		PanelBotonera = new javax.swing.JPanel();
		jButtonAceptar = new javax.swing.JButton();		 
		jButtonCancelar = new javax.swing.JButton();
		jLabel1 = new javax.swing.JLabel();

		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		jPanel2.setLayout(new java.awt.GridBagLayout());

		if (iProyectoFile != null) {
			jListListaPaquetes.setModel(new DefaultListModel() {
				/**
				 * 
				 */
				private static final long serialVersionUID = 299743174566491596L;
				File[] paquetes = iProyectoFile;

				// { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
				public int getSize() {
					return paquetes.length;
				}

				public Object getElementAt(int i) {
					return paquetes[i];
				}
			});
		}
		jListListaPaquetes.setCellRenderer(new RenderJlistPaquete());
		jListListaPaquetes
				.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
		jListListaPaquetes
				.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
					public void valueChanged(
							javax.swing.event.ListSelectionEvent evt) {
						jListListaPaquetesValueChanged(evt);
					}
				});

		jScrollPane1.setViewportView(jListListaPaquetes);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
		jPanel2.add(jScrollPane1, gridBagConstraints);

		jButtonAceptar.setText("Aceptar");
		jButtonAceptar.setToolTipText("Aceptar");
		jButtonAceptar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButtonAceptarActionPerformed(evt);
			}
		});

		PanelBotonera.add(jButtonAceptar);

		jButtonCancelar.setText("Cancelar");
		jButtonCancelar.setToolTipText("Cancelar");
		jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButtonCancelarActionPerformed(evt);
			}
		});

		PanelBotonera.add(jButtonCancelar);
		

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
		jPanel2.add(PanelBotonera, gridBagConstraints);

		jLabel1.setText("Elegir una carpeta fuente:");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
		jPanel2.add(jLabel1, gridBagConstraints);

		getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

		pack();
	}// </editor-fold>//GEN-END:initComponents

	

	/**
	 * Jlist lista paquetes value changed. Creado : Parras, 27-sep-2009
	 * 
	 * @param evt
	 *            the evt
	 */
	private void jListListaPaquetesValueChanged(
			javax.swing.event.ListSelectionEvent evt) {// GEN-FIRST:event_jListListaPaquetesValueChanged
		// Aqui guardaremos en nuestra variable la opcin y visualizamos aceptar
		jButtonAceptar.setEnabled(true);

	}// GEN-LAST:event_jListListaPaquetesValueChanged

	/**
	 * J button cancelar action performed. Creado : Parras, 27-sep-2009
	 * 
	 * @param evt
	 *            the evt
	 */
	private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_jButtonCancelarActionPerformed
	// Boton que cancela y cierra nuestra ventana
		this.dispose();
	}// GEN-LAST:event_jButtonCancelarActionPerformed

	/**
	 *  button aceptar action performed. Creado : Parras, 27-sep-2009
	 * 
	 * @param evt
	 *            the evt
	 */
	private void jButtonAceptarActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_jButtonAceptarActionPerformed
		// Este Debe darnos nuestra ruta completa
		
		if (jListListaPaquetes.getSelectedValue() instanceof File) {
			iProyectoSelecionado = (File) jListListaPaquetes.getSelectedValue();
		}

		this.dispose();
	}
	
	
	/**
	 * Clase que nos devuelve solo los proyecto que no tenemos insertados
	 * 
	 * @author Parras
	 */
	 class MiFiltroProyecto implements FileFilter{
		
		/** The is extension. */
		ArrayList<File> iaProyectos;
		
		/**
		 * Guarda nuestro proyectos para verificar si existe un nuevo File.
		 * 
		 * @param aProyecto
		 *            Proyectos cargados en nuestro sistema
		 */
		MiFiltroProyecto (File[] aProyecto) {
			if (aProyecto != null)			
				iaProyectos = new ArrayList<File>(Arrays.asList(aProyecto));
			else
				iaProyectos = new ArrayList<File>();
				
		}

		/* (non-Javadoc)
		 * @see java.io.FileFilter#accept(java.io.File)
		 */
		public boolean accept(File pathname) {
			if (iaProyectos == null)
				return false;
				
			return !iaProyectos.contains(pathname);
		}
	}
	
	  

	
	/**
	 * Devuelve el proyecto seleccionado.
	 * 
	 * @return File
	 */
	public File getProyectoSelecionado() {
		return iProyectoSelecionado;
	}


	/**
	 * RendereJlist. Aade al JList un reder con un icono de carpeta, para una
	 * grata visualizacin de los paquetes del proyecto.
	 * 
	 * @see javax.swing.List
	 */
	private class RenderJlistPaquete extends JLabel implements ListCellRenderer {

		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 1L;

		/*
		 * (non-Javadoc)
		 * 
		 * @see
		 * javax.swing.ListCellRenderer#getListCellRendererComponent(javax.swing
		 * .JList, java.lang.Object, int, boolean, boolean)
		 */
		public Component getListCellRendererComponent(JList arg0, Object arg1,
				int arg2, boolean arg3, boolean arg4) {
			// TODO Apndice de mtodo generado automticamente
			// System.out.print(arg1);

			if (arg1 instanceof PaqueteActivos) {
				PaqueteActivos paquete = (PaqueteActivos) arg1;
				this.setIcon(IconFactory.getImage("carpeta.gif"));
				this.setText(paquete.toString().substring(
						Editor.get().getWorkspace().toString().length()));

			}

			if (arg1 instanceof File) {
				File paquete = (File) arg1;
				this.setIcon(IconFactory.getImage("carpeta.gif"));
				this.setText(paquete.getName());
			}

			return this;
		}

	}
	


	// Variables declaration - do not modify//GEN-BEGIN:variables
	/** Panel botonera. */
	private javax.swing.JPanel PanelBotonera;


	/** button aceptar. */
	private javax.swing.JButton jButtonAceptar;

	/** button cancelar. */
	private javax.swing.JButton jButtonCancelar;

	/** label1. */
	private javax.swing.JLabel jLabel1;

	/** list lista paquetes. */
	private javax.swing.JList jListListaPaquetes;

	/** panel2. */
	private javax.swing.JPanel jPanel2;

	/** scroll pane1. */
	private javax.swing.JScrollPane jScrollPane1;
	// End of variables declaration//GEN-END:variables

	public javax.swing.JList getJListListaPaquetes() {
		return jListListaPaquetes;
	}

}
