/*
 * 
 * @author Manuel Parras  
 */

package proyecto.paneles;

import java.awt.Dimension;
import java.io.File;
import javax.swing.JFileChooser;
import proyecto.utilidades.OperacionesVentanas;



/**
 *SeleccionarWorkSpace
 * 
 * <p>
 * Debemos seleccionar un espacio de trabajo para el inicio de nuestra
 * aplicacin, para poder as trabajar con nuestros proyectos (despus del
 * workSpace se deber crear un proyecto).
 * </p> 
 * <p>
 * El espacio de trabajo ser buscado cuando pulsemos sobre el botn examinar,
 * que no abrir el JFileChooser para la ubicacin del mismo.
 * <p>
 * EL fichero de XML se guardar al final (cuando cerremos la aplicacin) con
 * toda la informacin recogida de la aplicacin.
 * </p>
 * <p>
 * Se guardar en /PFC/workspace.xml
 * </p>
 * <p>
 * En el caso de cancelar en la ventana no guardar nada referente a XML
 * necesarios.
 * </p>
 * 
 * @see proyecto.editor.Editor#guardarWorkSpaceXML()
 * @see javax.swing.JFileChooser
 */
public class SeleccionarWorkSpace extends javax.swing.JDialog {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Creates new form SeleccionarWorkspcae. */

	File iFWorkSpace;

	/**
	 * Constructor seleccionar workspcae.
	 * 
	 * Creado : Parras, 27-sep-2009
	 * 
	 * @param parent
	 *            the parent
	 * @param modal
	 *            the modal
	 */
	public SeleccionarWorkSpace(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		OperacionesVentanas.centraVentana(this);
		jBAceptar.setEnabled(false);
		this.setTitle("Seleccionar WorkSpace");
		this.pack();
		this.setMinimumSize(new Dimension(430, 208));
	}

	// <editor-fold defaultstate="collapsed" desc=" Generated Code ">
	/**
	 * Inits the components. Creado : Parras, 27-sep-2009
	 */
	private void initComponents() {
		java.awt.GridBagConstraints gridBagConstraints;

		jTextField1 = new javax.swing.JTextField();
		jPanel1 = new javax.swing.JPanel();
		jBAceptar = new javax.swing.JButton();
		jBCancelar = new javax.swing.JButton();
		jEditorPane1 = new javax.swing.JTextPane();
		jLabel1 = new javax.swing.JLabel();
		jBExaminar = new javax.swing.JButton();

		getContentPane().setLayout(new java.awt.GridBagLayout());

		setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
		jTextField1.setFocusable(false);
		;
		jTextField1.setEditable(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(4, 2, 2, 2);
		getContentPane().add(jTextField1, gridBagConstraints);

		jBAceptar.setText("Aceptar");
		jBAceptar.setMnemonic('A');
		jBAceptar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBAceptarActionPerformed(evt);
			}
		});

		jPanel1.add(jBAceptar);

		jBCancelar.setText("Cancelar");
		jBCancelar.setMnemonic('C');
		jBCancelar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBCancelarActionPerformed(evt);
			}
		});

		jPanel1.add(jBCancelar);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.gridwidth = 3;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
		getContentPane().add(jPanel1, gridBagConstraints);

		// jEditorPane1.setEditable(false);
		jEditorPane1.setContentType("text/html");
		jEditorPane1
				.setText("<html><h3>Seleccionar un espacio de Trabajo.</h3>EpSilon almacena los proyectos en un espacio de trabajo.<br>Elija un nombre de carpeta para el espacio de trabajo.</html>");
		// jEditorPane1.setToolTipText("<html><h5>Seleccionar un espacio de Trabajo.</h5><br>EpSilon almacena los proyectos en un espacio de trabajo.<br>Elija un nombre de carpeta para el espacio de trabajo.Seleccionar un espacio de Trabajo.</html>");
		jEditorPane1.setFocusable(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = 3;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 0.1;
		gridBagConstraints.insets = new java.awt.Insets(4, 4, 13, 4);
		getContentPane().add(jEditorPane1, gridBagConstraints);

		jLabel1.setText("WorkSpace:");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
		getContentPane().add(jLabel1, gridBagConstraints);

		jBExaminar.setText("Examinar");
		jBExaminar.setMnemonic('E');
		jBExaminar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jBExaminarActionPerformed(evt);
			}
		});

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 2;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
		getContentPane().add(jBExaminar, gridBagConstraints);

		pack();
	}// </editor-fold>

	/**
	 * examinar action performed.
	 * <p>
	 * Mtodo que gestiona el botn examinar; abriendo el JFileChooser en modo
	 * DIRECTORIES_ONLY
	 * </p>
	 * 
	 * @param evt
	 *            the evt
	 *            <p>
	 *            Creado : Parras, 27-sep-2009
	 *            </p>
	 *@see javax.swing.JFileChooser
	 */
	private void jBExaminarActionPerformed(java.awt.event.ActionEvent evt) {
		File lDirectorio = null;

		JFileChooser lChooser;

		lChooser = new JFileChooser(".");

		lChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

		int liReturn = lChooser.showDialog(this, "Seleccionar");

		if (liReturn == JFileChooser.APPROVE_OPTION) {

			lDirectorio = lChooser.getSelectedFile();

			jTextField1.setText(lDirectorio.getName());

			if (jTextField1.getText().equals(""))
				jBAceptar.setEnabled(false);
			else {
				jBAceptar.setEnabled(true);
				System.out.print("valor"+ lDirectorio.getParent() );
				if (lDirectorio.getParent() == null) //c:\
					jTextField1.setText(lDirectorio.getName() +"Workspace");
				else
				jTextField1.setText(lDirectorio.getName() +File.separator +"Workspace");
			}

		}
	}

	/**
	 * Aceptar action performed.
	 * <p>
	 * Verifica si el WorkSpace existe, en el caso de que no exista crea los
	 * direcrtorios necesarios
	 * </p>
	 * 
	 * @param evt
	 *            the evt
	 *            <p>
	 *            Creado : Parras, 27-sep-2009
	 *            </p>
	 */
	private void jBAceptarActionPerformed(java.awt.event.ActionEvent evt) {
		iFWorkSpace = new File(jTextField1.getText());
		if (iFWorkSpace.exists())
			this.dispose();
		else {
			if (iFWorkSpace.mkdirs())
				this.dispose();
		}

	}

	/**
	 * cancelar action performed
	 * <p>
	 * Si cancelamos la creaccin del workSpace cerrar por clompleto nuestro
	 * proyecto
	 * </p>
	 * .
	 * 
	 * @param evt
	 *            the evt
	 *            <p>
	 *            Creado : Parras, 27-sep-2009
	 *            </p>
	 */
	private void jBCancelarActionPerformed(java.awt.event.ActionEvent evt) {
		// System.out.print(this.getSize());
		System.exit(0);
	}

	/**
	 * Obtener el workSpace.
	 * 
	 * @return el workSpace de nustro proyecto
	 *         <p>
	 *         Creado : Parras, 27-sep-2009
	 *         </p>
	 */
	public File getWorkSpace() {
		return iFWorkSpace;
	}

	/**
	 * Modificar la propiedad workSpace.
	 * 
	 * @param aWorkSpace
	 *            La propiedad workSpace
	 *            <p>
	 *            Creado : Parras, 27-sep-2009
	 *            </p>
	 */
	public void setWorkSpace(File aWorkSpace) {
		iFWorkSpace = aWorkSpace;
	}

	/**
	 * The main method.
	 * 
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new SeleccionarWorkSpace(new javax.swing.JFrame(), true)
						.setVisible(true);
			}
		});
	}

	// Variables declaration - do not modify
	/** aceptar. */
	private javax.swing.JButton jBAceptar;

	/** cancelar. */
	private javax.swing.JButton jBCancelar;

	/** examinar. */
	private javax.swing.JButton jBExaminar;

	/** editor pane1. */
	private javax.swing.JTextPane jEditorPane1;

	/** label1. */
	private javax.swing.JLabel jLabel1;

	/** panel1. */
	private javax.swing.JPanel jPanel1;

	/** text field1. */
	private javax.swing.JTextField jTextField1;
	// End of variables declaration

}
