/*
 * 
 * @author Manuel Parras  
 */
package proyecto.preferencias;


/**
 * Clase ItemDeLista. ItemDeLista<br>
 * 
 * Es un objeto intermedio que usamos para no tener dependencia de las palabras
 * reservadas que tiene la librera syntax.jar. Esta utilidad nos es til a la
 * hora de crear una estructura (map) podemos referenciar la palabra reservada
 * (etiqueta) y la que usaremos para pintarla en nuestra GUI(tituloOpcion)
 * 
 * <br> Creado: Manuel Parras.
 * @see java.util.HashMap

 */
public class ItemDeLista {

	/**
	 * Es la etiqueta que guardara la palabra reservada que necesita nuestra
	 * libreria para que reconzca las palbras reservdas.
	 */
	private String etiqueta;

	/**
	 * Esta tituloOpcion es el nombre que le daremos a nuestra paralabra
	 * reservada, para hacer nostro nuestra propia intepretecion.
	 */
	private String tituloOpcion;

	/**
	 * Constructor de la clase ItemDeLista
	 * 
	 * @param e
	 *            the e
	 * @param t
	 *            the t
	 */
	public ItemDeLista(String e, String t) {
		etiqueta = e;
		tituloOpcion = t;
	}

	/**
	 * Obtener sobre nombre de la plabra reservada
	 * 
	 * @return etiqueta
	 */
	public String getEtiqueta() {
		return etiqueta;
	}

	/**
	 * Devuelve el titulo asignado a nuestra tipo de palabra reservada.
	 * 
	 * @return tituloOpcion
	 */
	public String getTituloOpcion() {
		return tituloOpcion;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return tituloOpcion;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {

		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((etiqueta == null) ? 0 : etiqueta.hashCode());

		// Nuestro objetos seran iguales solo por su etiqueta el titulo solo no
		// sirve
		// para su representacin en pantalla visual
		// result = PRIME * result + ((tituloOpcion == null) ? 0 :
		// tituloOpcion.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {

		ItemDeLista item = (ItemDeLista) obj;

		if (item != null)
			if (etiqueta.equals(item.getEtiqueta()))
				return true;
			else
				return false;
		else
			return false;
		// if (this == obj)
		// return true;
		// if (obj == null)
		// return false;
		// if (getClass() != obj.getClass())
		// return false;
		// final ItemDeLista other = (ItemDeLista) obj;
		// if (etiqueta == null) {
		// if (other.etiqueta != null)
		// return false;
		// } else if (!etiqueta.equals(other.etiqueta))
		// return false;
		// // if (tituloOpcion == null) {
		// if (other.tituloOpcion != null)
		// return false;
		// } else if (!tituloOpcion.equals(other.tituloOpcion))
		// return false;
		// return true;
	}

}
