/* The following code was generated by JFlex 1.4.1 on 23/06/07 14:53 */

/* JavaCCLexer.java is a generated file.  You probably want to
 * edit JavaLexer.lex to make changes.  Use JFlex to generate it.
 * To generate JavaLexer.java
 * Install <a href="http://jflex.de/">JFlex</a> v1.3.2 or later.
 * Once JFlex is in your classpath run<br>
 * <code>java JFlex.Main JavaLexer.lex</code><br>
 * You will then have a file called JavaLexer.java
 */


package proyecto.sintaxis;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import com.Ostermiller.Syntax.Lexer.Lexer;
import com.Ostermiller.Syntax.Lexer.Token;

/** 
 * JavaLexer is a java lexer.  Created with JFlex.  An example of how it is used:
 *  <CODE>
 *  <PRE>
 *  JavaLexer shredder = new JavaLexer(System.in);
 *  JavaToken t;
 *  while ((t = shredder.getNextToken()) != null){
 *      System.out.println(t);
 *  }
 *  </PRE>
 *  </CODE>
 * The tokens returned should comply with the 
 * <A Href=http://java.sun.com/docs/books/jls/html/>Java 
 * Language Specification</A>.
 * @see JavaCCToken
 */ 


public class JavaCCLexer implements Lexer {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  public static final int YYINITIAL = 0;

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = {
     0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  9,  0,  7,  9,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     7, 44, 18,  0,  6, 10, 48, 17, 33, 34, 20, 21, 40, 22, 32, 19, 
     4,  5,  5,  5,  3,  3,  3,  3,  2,  2, 47, 39, 43, 41, 42, 46, 
     0, 67,  1, 74, 31, 28, 29, 70, 68, 69, 77, 66, 24, 80, 71, 65, 
    76,  6, 72, 75, 79,  6, 78,  6, 26,  6,  6, 37,  8, 38, 50, 73, 
     0, 51, 14, 53, 30, 27, 15, 59, 57, 58,  6, 55, 23, 60, 13, 54, 
    61,  6, 12, 52, 16, 11, 62, 63, 25, 56, 64, 35, 49, 36, 45,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
  };

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\1\2\2\3\1\4\1\1\1\5\5\2"+
    "\1\6\1\7\1\10\1\11\1\12\1\13\5\2\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\17\2\1\37\1\40\1\41\1\37\2\42"+
    "\1\37\2\43\1\44\2\37\2\45\1\1\1\46\15\2"+
    "\1\47\1\0\1\50\1\51\1\52\1\53\1\54\1\55"+
    "\1\56\1\57\1\60\1\61\1\62\6\2\1\63\1\42"+
    "\1\45\1\64\1\65\1\66\1\67\1\70\1\71\1\72"+
    "\1\73\1\74\1\75\1\76\14\2\1\77\16\2\1\42"+
    "\1\0\1\100\1\101\1\45\1\0\1\1\2\2\1\102"+
    "\6\2\1\103\3\2\1\104\2\2\1\6\1\0\1\105"+
    "\2\47\1\6\2\51\1\7\2\54\4\2\1\106\2\2"+
    "\1\40\1\0\1\42\1\44\1\0\1\45\1\107\1\110"+
    "\1\111\15\2\1\112\21\2\1\42\1\113\1\45\1\1"+
    "\1\2\1\114\3\2\1\115\2\2\1\116\2\2\1\117"+
    "\1\6\1\120\1\51\1\0\2\54\1\121\1\122\1\2"+
    "\1\123\3\2\1\124\11\2\1\125\2\2\1\126\5\2"+
    "\1\127\5\2\1\130\2\2\1\131\4\2\1\132\1\1"+
    "\2\2\1\133\1\2\1\134\1\135\1\2\1\136\1\6"+
    "\1\51\1\0\1\137\5\2\1\140\3\2\1\141\1\2"+
    "\1\142\1\143\1\2\1\144\12\2\1\145\4\2\1\146"+
    "\1\147\1\150\3\2\1\151\1\6\1\51\1\0\3\2"+
    "\1\152\2\2\1\153\1\2\1\154\5\2\1\155\1\156"+
    "\11\2\1\157\1\160\1\2\1\0\1\2\1\161\1\162"+
    "\4\2\1\163\4\2\1\164\1\165\7\2\1\0\1\2"+
    "\1\166\1\167\1\2\1\170\4\2\1\171\4\2\1\172"+
    "\1\2\1\173\1\174\1\2\1\175\2\2\1\176\6\2"+
    "\1\177\1\200\3\2\1\201\2\2\1\202\3\2\1\203"+
    "\1\2\1\204\1\2\1\205\2\2\1\206";

  private static int [] zzUnpackAction() {
    int [] result = new int[444];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\121\0\242\0\363\0\u0144\0\u0195\0\u01e6\0\u0237"+
    "\0\u0288\0\u02d9\0\u032a\0\u037b\0\u03cc\0\u041d\0\u046e\0\u04bf"+
    "\0\u0510\0\u0561\0\u05b2\0\u0603\0\u0654\0\u06a5\0\u06f6\0\u0747"+
    "\0\u0798\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u07e9"+
    "\0\u07e9\0\u083a\0\u088b\0\u08dc\0\u092d\0\u07e9\0\u07e9\0\u07e9"+
    "\0\u097e\0\u09cf\0\u0a20\0\u0a71\0\u0ac2\0\u0b13\0\u0b64\0\u0bb5"+
    "\0\u0c06\0\u0c57\0\u0ca8\0\u0cf9\0\u0d4a\0\u0d9b\0\u0dec\0\u0e3d"+
    "\0\u0e8e\0\u0edf\0\u0f30\0\u0f30\0\u0f30\0\u0f81\0\u0f30\0\u0fd2"+
    "\0\u1023\0\u1074\0\u10c5\0\u0f30\0\u1116\0\u1167\0\u0f30\0\u11b8"+
    "\0\u1209\0\u07e9\0\u125a\0\u12ab\0\u12fc\0\u134d\0\u139e\0\u13ef"+
    "\0\u1440\0\u1491\0\u14e2\0\u1533\0\u1584\0\u15d5\0\u1626\0\u1677"+
    "\0\u16c8\0\u07e9\0\u1719\0\u07e9\0\u176a\0\u17bb\0\u07e9\0\u07e9"+
    "\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u180c\0\u185d\0\u18ae\0\u18ff"+
    "\0\u1950\0\u19a1\0\u19f2\0\u1a43\0\u1a94\0\u07e9\0\u07e9\0\u1ae5"+
    "\0\u07e9\0\u1b36\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u07e9\0\u07e9"+
    "\0\u1b87\0\u1bd8\0\u1c29\0\u1c7a\0\u1ccb\0\u1d1c\0\u1d6d\0\u1dbe"+
    "\0\u1e0f\0\u1e60\0\u1eb1\0\u1f02\0\242\0\u1f53\0\u1fa4\0\u1ff5"+
    "\0\u2046\0\u2097\0\u20e8\0\u2139\0\u218a\0\u21db\0\u222c\0\u227d"+
    "\0\u22ce\0\u231f\0\u2370\0\u23c1\0\u2412\0\u0f30\0\u2463\0\u24b4"+
    "\0\u2505\0\u2556\0\u25a7\0\u25f8\0\242\0\u2649\0\u269a\0\u26eb"+
    "\0\u273c\0\u278d\0\u27de\0\242\0\u282f\0\u2880\0\u28d1\0\242"+
    "\0\u2922\0\u2973\0\u29c4\0\u2a15\0\u07e9\0\u2a66\0\u2ab7\0\u2b08"+
    "\0\u2b59\0\u2baa\0\u2bfb\0\u2c4c\0\u2c9d\0\u2cee\0\u2d3f\0\u2d90"+
    "\0\u2de1\0\242\0\u2e32\0\u2e83\0\u07e9\0\u2ed4\0\u07e9\0\u07e9"+
    "\0\u2f25\0\u07e9\0\u07e9\0\u2f76\0\u07e9\0\u2fc7\0\u3018\0\u3069"+
    "\0\u30ba\0\u310b\0\u315c\0\u31ad\0\u31fe\0\u324f\0\u32a0\0\u32f1"+
    "\0\u3342\0\u3393\0\u33e4\0\u3435\0\u3486\0\u34d7\0\u3528\0\u3579"+
    "\0\u35ca\0\u361b\0\u366c\0\u36bd\0\u370e\0\u375f\0\u37b0\0\u3801"+
    "\0\u3852\0\u38a3\0\u38f4\0\u3945\0\u3996\0\u0f30\0\u39e7\0\u3a38"+
    "\0\u3a89\0\242\0\u3ada\0\u3b2b\0\u3b7c\0\242\0\u3bcd\0\u3c1e"+
    "\0\242\0\u3c6f\0\u3cc0\0\242\0\u3d11\0\u07e9\0\u3d62\0\u3db3"+
    "\0\u3e04\0\u3e55\0\u07e9\0\242\0\u3ea6\0\242\0\u3ef7\0\u3f48"+
    "\0\u3f99\0\u07e9\0\u3fea\0\u403b\0\u408c\0\u40dd\0\u412e\0\u417f"+
    "\0\u41d0\0\u4221\0\u4272\0\242\0\u42c3\0\u4314\0\242\0\u4365"+
    "\0\u43b6\0\u4407\0\u4458\0\u44a9\0\242\0\u44fa\0\u454b\0\u459c"+
    "\0\u45ed\0\u463e\0\242\0\u468f\0\u46e0\0\242\0\u4731\0\u4782"+
    "\0\u47d3\0\u4824\0\242\0\u4875\0\u48c6\0\u4917\0\242\0\u4968"+
    "\0\242\0\u49b9\0\u4a0a\0\u4a5b\0\u4aac\0\u4afd\0\u4b4e\0\u07e9"+
    "\0\u4b9f\0\u4bf0\0\u4c41\0\u4c92\0\u4ce3\0\242\0\u4d34\0\u4d85"+
    "\0\u4dd6\0\242\0\u4e27\0\242\0\242\0\u4e78\0\242\0\u4ec9"+
    "\0\u4f1a\0\u4f6b\0\u4fbc\0\u500d\0\u505e\0\u50af\0\u5100\0\u5151"+
    "\0\u51a2\0\242\0\u51f3\0\u5244\0\u5295\0\u52e6\0\u5337\0\242"+
    "\0\242\0\u5388\0\u53d9\0\u542a\0\242\0\u547b\0\u54cc\0\u551d"+
    "\0\u556e\0\u55bf\0\u5610\0\242\0\u5661\0\u56b2\0\242\0\u5703"+
    "\0\242\0\u5754\0\u57a5\0\u57f6\0\u5847\0\u5898\0\242\0\242"+
    "\0\u58e9\0\u593a\0\u598b\0\u59dc\0\u5a2d\0\u5a7e\0\u5acf\0\u5b20"+
    "\0\u5b71\0\242\0\242\0\u5bc2\0\u5c13\0\u5c64\0\242\0\242"+
    "\0\u5cb5\0\u5d06\0\u5d57\0\u5da8\0\242\0\u5df9\0\u5e4a\0\u5e9b"+
    "\0\u5eec\0\242\0\242\0\u5f3d\0\u5f8e\0\u5fdf\0\u6030\0\u6081"+
    "\0\u60d2\0\u6123\0\u6174\0\u61c5\0\242\0\242\0\u6216\0\242"+
    "\0\u6267\0\u62b8\0\u6309\0\u635a\0\242\0\u63ab\0\u63fc\0\u644d"+
    "\0\u649e\0\242\0\u64ef\0\242\0\242\0\u6540\0\242\0\u6591"+
    "\0\u65e2\0\242\0\u6633\0\u6684\0\u66d5\0\u6726\0\u6777\0\u67c8"+
    "\0\242\0\242\0\u6819\0\u686a\0\u68bb\0\242\0\u690c\0\u695d"+
    "\0\242\0\u69ae\0\u69ff\0\u6a50\0\242\0\u6aa1\0\242\0\u6af2"+
    "\0\242\0\u6b43\0\u6b94\0\242";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[444];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\2\1\3\2\4\1\5\1\4\1\3\1\6\1\7"+
    "\1\6\1\10\1\3\1\11\1\12\1\13\1\14\1\15"+
    "\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25"+
    "\2\3\1\26\1\27\1\3\1\30\1\3\1\31\1\32"+
    "\1\33\1\34\1\35\1\36\1\37\1\40\1\41\1\42"+
    "\1\43\1\44\1\45\1\46\1\47\1\50\1\51\1\52"+
    "\1\53\1\54\1\55\1\56\1\57\3\3\1\60\1\61"+
    "\1\3\1\62\1\63\1\64\5\3\1\65\5\3\1\66"+
    "\1\67\1\70\1\3\1\71\1\72\7\2\1\0\1\2"+
    "\2\0\6\2\6\0\11\2\23\0\37\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\36\3\2\73"+
    "\4\4\1\73\1\0\1\73\2\0\4\73\1\74\1\73"+
    "\6\0\2\75\2\73\2\76\1\74\2\77\1\100\22\0"+
    "\40\73\1\101\1\102\1\103\1\102\1\73\1\0\1\73"+
    "\2\0\4\73\1\104\1\73\6\0\2\75\2\105\2\106"+
    "\1\104\2\107\1\110\22\0\36\73\7\0\1\6\1\0"+
    "\1\6\107\0\7\2\1\0\1\2\2\0\1\111\5\2"+
    "\6\0\11\2\23\0\36\2\51\0\1\112\47\0\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\4\3\1\113"+
    "\4\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\1\114\5\3\6\0\4\3\1\115\4\3\23\0\1\116"+
    "\35\3\1\2\6\3\1\0\1\7\2\0\1\3\1\117"+
    "\4\3\6\0\11\3\23\0\3\3\1\120\1\3\1\121"+
    "\30\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\1\122\10\3\23\0\1\123\2\3\1\124\3\3\1\125"+
    "\26\3\1\2\6\3\1\0\1\7\2\0\1\3\1\126"+
    "\4\3\6\0\11\3\23\0\6\3\1\127\27\3\10\130"+
    "\1\131\1\0\7\130\1\132\77\130\10\17\1\133\1\0"+
    "\10\17\1\134\76\17\23\0\1\135\1\136\24\0\1\137"+
    "\120\0\1\140\74\0\1\141\23\0\1\142\75\0\1\143"+
    "\22\0\1\144\47\0\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\3\3\1\145\32\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\16\3\1\146\17\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\147\1\3\1\150\6\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\16\3\1\151\17\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\152\4\3\23\0\3\3"+
    "\1\153\32\3\2\0\2\154\1\155\1\154\305\0\1\156"+
    "\120\0\1\157\1\160\117\0\1\161\1\0\1\162\116\0"+
    "\1\163\120\0\1\164\6\0\1\165\111\0\1\166\7\0"+
    "\1\167\110\0\1\170\47\0\1\2\6\3\1\0\1\7"+
    "\2\0\3\3\1\171\2\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\1\172\4\3\1\173"+
    "\6\0\11\3\23\0\5\3\1\174\1\175\5\3\1\176"+
    "\21\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\1\177\10\3\23\0\1\200\2\3\1\201\2\3\1\202"+
    "\27\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\12\3\1\203\23\3\1\2\6\3\1\0"+
    "\1\7\2\0\2\3\1\204\1\3\1\205\1\3\6\0"+
    "\11\3\23\0\11\3\1\206\24\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\3\3\1\207"+
    "\32\3\1\2\6\3\1\0\1\7\2\0\1\210\1\211"+
    "\4\3\6\0\11\3\23\0\1\212\35\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\3\3"+
    "\1\213\32\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\6\3\1\214\27\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\23\3"+
    "\1\215\12\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\17\3\1\216\11\3\1\217\4\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\20\3\1\220\15\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\20\3\1\221\15\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\16\3\1\222\17\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\16\3\1\223\17\3"+
    "\7\73\1\0\1\73\2\0\6\73\6\0\12\73\22\0"+
    "\40\73\4\224\1\73\1\0\1\73\2\0\6\73\4\0"+
    "\2\225\12\73\22\0\40\73\4\100\1\73\1\0\1\73"+
    "\2\0\4\73\1\74\1\73\6\0\4\73\2\76\1\74"+
    "\2\77\1\73\22\0\40\73\4\101\1\73\1\0\1\73"+
    "\2\0\4\73\1\74\1\73\6\0\4\73\2\76\1\74"+
    "\2\77\1\100\22\0\40\73\1\101\3\102\1\73\1\0"+
    "\1\73\2\0\4\73\1\74\1\73\6\0\2\226\2\73"+
    "\2\76\1\74\2\77\1\100\22\0\40\73\1\101\1\102"+
    "\1\103\1\102\1\73\1\0\1\73\2\0\4\73\1\104"+
    "\1\73\6\0\2\226\2\73\2\106\1\104\2\107\1\110"+
    "\22\0\37\73\5\227\1\73\1\0\1\73\2\0\3\73"+
    "\2\227\1\73\6\0\4\73\5\227\1\73\22\0\1\227"+
    "\1\73\1\227\15\73\1\227\6\73\1\227\10\73\4\230"+
    "\1\73\1\0\1\73\2\0\6\73\4\0\2\231\12\73"+
    "\22\0\40\73\2\100\1\110\1\100\1\73\1\0\1\73"+
    "\2\0\4\73\1\104\1\73\6\0\4\73\2\106\1\104"+
    "\2\107\1\73\22\0\36\73\1\2\5\232\1\2\1\0"+
    "\1\2\2\0\3\2\2\232\1\2\6\0\4\2\5\232"+
    "\23\0\1\232\1\2\1\232\15\2\1\232\6\2\1\232"+
    "\7\2\6\3\1\0\1\7\2\0\5\3\1\233\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\234\10\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\14\3"+
    "\1\235\21\3\1\2\6\3\1\0\1\7\2\0\5\3"+
    "\1\236\6\0\11\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\4\3\1\237\4\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\3\3\1\240\32\3\1\2\6\3\1\0"+
    "\1\7\2\0\5\3\1\241\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\3\3\1\242\32\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\1\243\10\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\1\3\1\244\4\3\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\2\3\1\245\3\3\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\1\246\5\3\6\0\11\3"+
    "\23\0\1\247\4\3\1\250\30\3\1\2\6\3\1\0"+
    "\1\7\2\0\1\3\1\251\4\3\6\0\11\3\23\0"+
    "\7\3\1\252\26\3\10\253\1\254\1\0\7\253\1\255"+
    "\102\253\1\256\2\257\2\253\1\130\1\0\1\253\1\260"+
    "\7\130\76\253\3\261\3\17\2\261\1\17\1\0\1\261"+
    "\1\262\6\17\1\263\76\261\11\135\1\0\107\135\24\264"+
    "\1\265\74\264\1\2\6\3\1\0\1\7\2\0\2\3"+
    "\1\266\3\3\6\0\11\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\16\3"+
    "\1\267\17\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\1\3\1\270\34\3\1\2\6\3"+
    "\1\0\1\7\2\0\5\3\1\271\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\6\3\1\272\2\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\4\3\1\273\1\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\1\274\5\3"+
    "\6\0\11\3\23\0\36\3\2\0\4\154\11\0\1\275"+
    "\13\0\2\276\1\275\2\277\63\0\2\154\1\155\1\154"+
    "\11\0\1\300\13\0\2\301\1\300\2\302\132\0\1\303"+
    "\1\304\117\0\1\305\47\0\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\1\3\1\306\34\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\12\3\1\307\23\3\1\2\6\3\1\0\1\7"+
    "\2\0\1\3\1\310\4\3\6\0\11\3\23\0\1\311"+
    "\35\3\1\2\6\3\1\0\1\7\2\0\2\3\1\312"+
    "\3\3\6\0\11\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\3\3\1\313"+
    "\32\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\7\3\1\314\26\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\1\315\35\3"+
    "\1\2\6\3\1\0\1\7\2\0\5\3\1\316\6\0"+
    "\11\3\23\0\1\3\1\317\34\3\1\2\6\3\1\0"+
    "\1\7\2\0\2\3\1\320\3\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\321\35\3\1\2\6\3\1\0\1\7"+
    "\2\0\5\3\1\322\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\5\3\1\323\6\0\11\3"+
    "\23\0\1\3\1\324\34\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\12\3\1\325\23\3"+
    "\1\2\6\3\1\0\1\7\2\0\5\3\1\326\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\3\3\1\327\2\3\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\3\3\1\330\3\3\1\331\26\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\2\3\1\332"+
    "\33\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\1\333\10\3\23\0\7\3\1\334\26\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\7\3"+
    "\1\335\26\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\24\3\1\336\11\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\22\3"+
    "\1\337\13\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\5\3\1\340\3\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\25\3"+
    "\1\341\10\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\33\3\1\342\2\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\17\3"+
    "\1\343\16\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\25\3\1\344\10\3\2\73\4\224"+
    "\1\73\1\0\1\73\2\0\4\73\1\74\1\73\6\0"+
    "\6\73\1\74\2\77\1\73\22\0\36\73\2\0\4\345"+
    "\113\0\1\73\5\227\1\73\1\0\1\73\2\0\3\73"+
    "\2\227\1\73\6\0\2\346\2\73\5\227\1\73\22\0"+
    "\1\227\1\73\1\227\15\73\1\227\6\73\1\227\10\73"+
    "\4\230\1\73\1\0\1\73\2\0\4\73\1\104\1\73"+
    "\6\0\6\73\1\104\2\107\1\73\22\0\36\73\2\0"+
    "\4\347\113\0\1\2\5\350\1\2\1\0\1\2\2\0"+
    "\3\2\2\350\1\2\6\0\4\2\5\350\23\0\1\350"+
    "\1\2\1\350\15\2\1\350\6\2\1\350\7\2\6\3"+
    "\1\0\1\7\2\0\1\351\5\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\1\352\10\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\7\3\1\353\26\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\1\354\35\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\355\10\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\4\3\1\356\4\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\1\357\35\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\1\3\1\246"+
    "\34\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\360\35\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\361\4\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\2\3\1\362\3\3"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\3\3\1\363\32\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\1\3\1\364\34\3\10\253\1\254\1\0\7\253"+
    "\1\132\110\253\1\0\112\253\3\130\2\253\1\254\1\0"+
    "\7\253\1\255\102\253\3\256\2\253\1\254\1\0\7\253"+
    "\1\255\100\253\5\365\2\253\1\254\1\0\4\253\2\365"+
    "\1\253\1\132\11\253\5\365\23\253\1\365\1\253\1\365"+
    "\15\253\1\365\6\253\1\365\6\253\11\261\1\0\10\261"+
    "\1\366\77\261\5\367\3\261\1\0\4\261\2\367\2\261"+
    "\1\366\10\261\5\367\23\261\1\367\1\261\1\367\15\261"+
    "\1\367\6\261\1\367\6\261\10\263\1\370\1\0\10\263"+
    "\1\134\76\263\24\264\1\371\74\264\23\372\1\373\1\265"+
    "\74\372\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\10\3\1\374\25\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\17\3\1\375"+
    "\16\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\4\3\1\376\4\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\4\3\1\377\4\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\u0100\35\3\1\2\6\3\1\0\1\7"+
    "\2\0\3\3\1\u0101\2\3\6\0\11\3\23\0\36\3"+
    "\2\0\4\345\17\0\2\225\74\0\4\347\17\0\2\231"+
    "\143\0\1\u0102\47\0\1\2\6\3\1\0\1\7\2\0"+
    "\5\3\1\u0103\6\0\11\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\4\3\1\u0104\4\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\7\3\1\u0105\26\3\1\2\6\3"+
    "\1\0\1\7\2\0\5\3\1\u0106\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\2\3\1\u0107\33\3\1\2\6\3\1\0"+
    "\1\7\2\0\1\3\1\u0108\4\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\5\3\1\u0109"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\1\3\1\u010a\34\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\2\3\1\u010b\33\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\u010c\4\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\5\3\1\u010d\6\0"+
    "\11\3\23\0\1\3\1\u010e\34\3\1\2\6\3\1\0"+
    "\1\7\2\0\1\3\1\u010f\4\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\7\3\1\u0110\26\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\4\3\1\u0111\4\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\5\3\1\u0112"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\1\u0113\10\3\23\0\3\3\1\u0114"+
    "\32\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\3\3\1\u0115\32\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\1\u0116\10\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\5\3\1\u0117\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\13\3\1\u0118\22\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\4\3\1\u0119\31\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\1\u011a\35\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\7\3\1\u011b\1\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\1\u011c\10\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\16\3\1\u011d"+
    "\17\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\31\3\1\u011e\4\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\27\3\1\u011f"+
    "\6\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\30\3\1\u0120\5\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\20\3\1\u0121"+
    "\15\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\5\3\1\u0122\3\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\5\3\1\u0123\3\3\23\0"+
    "\36\3\2\0\4\345\11\0\1\275\15\0\1\275\2\277"+
    "\63\0\4\347\11\0\1\300\15\0\1\300\2\302\61\0"+
    "\1\2\5\u0124\1\2\1\0\1\2\2\0\3\2\2\u0124"+
    "\1\2\6\0\4\2\5\u0124\23\0\1\u0124\1\2\1\u0124"+
    "\15\2\1\u0124\6\2\1\u0124\7\2\6\3\1\0\1\7"+
    "\2\0\1\3\1\u0125\4\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\13\3\1\u0126\22\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\4\3\1\u0127\31\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\4\3"+
    "\1\u0128\4\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\5\3\1\u0129\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\1\u012a\10\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\1\3\1\u012b\34\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\14\3"+
    "\1\u012c\21\3\1\253\5\u012d\2\253\1\254\1\0\4\253"+
    "\2\u012d\1\253\1\132\11\253\5\u012d\23\253\1\u012d\1\253"+
    "\1\u012d\15\253\1\u012d\6\253\1\u012d\6\253\1\261\5\u012e"+
    "\3\261\1\0\4\261\2\u012e\2\261\1\366\10\261\5\u012e"+
    "\23\261\1\u012e\1\261\1\u012e\15\261\1\u012e\6\261\1\u012e"+
    "\6\261\3\0\3\263\2\0\1\263\2\0\1\u012f\7\263"+
    "\76\0\23\264\1\u0130\1\371\74\264\24\372\1\265\74\372"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\20\3\1\u0131\15\3\1\2\6\3\1\0\1\7"+
    "\2\0\2\3\1\u0132\3\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\1\u0133\5\3\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\u0134\10\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\1\3\1\u0135\4\3\6\0\11\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\1\3"+
    "\1\u0136\4\3\6\0\11\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\2\3"+
    "\1\u0137\33\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\7\3\1\u0138\26\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\6\3"+
    "\1\u0139\27\3\1\2\6\3\1\0\1\7\2\0\5\3"+
    "\1\u013a\6\0\11\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\2\3\1\u013b"+
    "\33\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\3\1\u013c\34\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\6\3\1\u013d"+
    "\27\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\7\3\1\u013e\26\3\1\2\6\3\1\0"+
    "\1\7\2\0\5\3\1\u013f\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\3\3\1\u0140\32\3\1\2\6\3\1\0\1\7"+
    "\2\0\1\3\1\u0141\4\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\1\u0142\35\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\4\3\1\u0143\4\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\1\3\1\u0144\4\3\6\0"+
    "\11\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\7\3\1\u0145\26\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\4\3\1\u0146"+
    "\4\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\1\u0147\35\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\1\u0148"+
    "\35\3\1\2\6\3\1\0\1\7\2\0\5\3\1\u0149"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\u014a\4\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\25\3\1\u014b\10\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\22\3\1\u014c\13\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\5\3"+
    "\1\u014d\3\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\27\3\1\u014e\6\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\24\3\1\u014f\11\3\1\2\5\3\1\2\1\0"+
    "\1\2\2\0\3\2\2\3\1\2\6\0\4\2\5\3"+
    "\23\0\1\3\1\2\1\3\15\2\1\3\6\2\1\3"+
    "\7\2\6\3\1\0\1\7\2\0\2\3\1\u0150\3\3"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\u0151\4\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\1\u0152\35\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\u0153\10\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\7\3"+
    "\1\u0154\26\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\1\3\1\u0155\34\3\1\253\5\u0156"+
    "\2\253\1\254\1\0\4\253\2\u0156\1\253\1\132\11\253"+
    "\5\u0156\23\253\1\u0156\1\253\1\u0156\15\253\1\u0156\6\253"+
    "\1\u0156\6\253\1\261\5\u0157\3\261\1\0\4\261\2\u0157"+
    "\2\261\1\366\10\261\5\u0157\23\261\1\u0157\1\261\1\u0157"+
    "\15\261\1\u0157\6\261\1\u0157\6\261\1\0\5\u0158\10\0"+
    "\2\u0158\13\0\5\u0158\23\0\1\u0158\1\0\1\u0158\15\0"+
    "\1\u0158\6\0\1\u0158\6\0\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\21\3\1\u0159\14\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\7\3"+
    "\1\u015a\1\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\1\u015b\10\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\4\3\1\u015c"+
    "\4\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\1\u015d\35\3\1\2\6\3"+
    "\1\0\1\7\2\0\5\3\1\u015e\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\2\3\1\u015f\33\3\1\2\6\3\1\0"+
    "\1\7\2\0\1\3\1\u0160\4\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\6\3\1\u0161\27\3\1\2\6\3\1\0"+
    "\1\7\2\0\2\3\1\u0162\3\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\2\3\1\u0163"+
    "\3\3\6\0\11\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\4\3\1\u0164\1\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\2\3\1\u0165"+
    "\3\3\6\0\11\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\11\3\1\u0166"+
    "\24\3\1\2\6\3\1\0\1\7\2\0\5\3\1\u0167"+
    "\6\0\11\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\2\3\1\u0168\33\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\2\3\1\u0169\33\3\1\2\6\3\1\0\1\7"+
    "\2\0\5\3\1\u016a\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\10\3\1\u016b\25\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\7\3\1\u016c\26\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\5\3\1\u016d"+
    "\3\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\20\3\1\u016e\15\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\25\3\1\u016f\10\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\16\3\1\u0170\17\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\26\3\1\u0171\7\3\1\2\6\3\1\0\1\7\2\0"+
    "\2\3\1\u0172\3\3\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\5\3\1\u0173\30\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\4\3\1\u0174\4\3\23\0\36\3\1\253"+
    "\5\130\2\253\1\254\1\0\4\253\2\130\1\253\1\132"+
    "\11\253\5\130\23\253\1\130\1\253\1\130\15\253\1\130"+
    "\6\253\1\130\6\253\1\261\5\17\3\261\1\0\4\261"+
    "\2\17\2\261\1\366\10\261\5\17\23\261\1\17\1\261"+
    "\1\17\15\261\1\17\6\261\1\17\6\261\1\0\5\u0175"+
    "\10\0\2\u0175\13\0\5\u0175\23\0\1\u0175\1\0\1\u0175"+
    "\15\0\1\u0175\6\0\1\u0175\6\0\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\5\3\1\u0176\3\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\3\1\u0177\34\3\1\2\6\3\1\0"+
    "\1\7\2\0\5\3\1\u0178\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\2\3\1\u0179\33\3\1\2\6\3\1\0\1\7"+
    "\2\0\4\3\1\u017a\1\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\3\3\1\u017b\32\3\1\2\6\3\1\0\1\7"+
    "\2\0\1\u017c\5\3\6\0\11\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\1\3\1\u017d\34\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\1\u017e\35\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\11\3\23\0\2\3"+
    "\1\u017f\33\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\4\3\1\u0180\4\3\23\0\36\3\1\2\6\3"+
    "\1\0\1\7\2\0\5\3\1\u0181\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\4\3\1\u0182\4\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\4\3\1\u0183\4\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\1\u0184\10\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\26\3\1\u0185\7\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\1\3"+
    "\1\u0186\7\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\26\3\1\u0187\7\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\10\3"+
    "\1\u0188\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\35\3\1\u0189\1\2\6\3"+
    "\1\0\1\7\2\0\2\3\1\u018a\3\3\6\0\11\3"+
    "\23\0\36\3\1\0\5\u018b\10\0\2\u018b\13\0\5\u018b"+
    "\23\0\1\u018b\1\0\1\u018b\15\0\1\u018b\6\0\1\u018b"+
    "\6\0\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\20\3\1\u018c\15\3\1\2\6\3\1\0"+
    "\1\7\2\0\5\3\1\u018d\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\12\3\1\u018e\23\3\1\2\6\3\1\0\1\7"+
    "\2\0\2\3\1\u018f\3\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\4\3"+
    "\1\u0190\4\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\2\3\1\u0191\33\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\4\3"+
    "\1\u0192\4\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\2\3\1\u0193\3\3\6\0\11\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\4\3"+
    "\1\u0194\4\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\4\3\1\u0195\4\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\27\3\1\u0196\6\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\26\3\1\u0197\7\3"+
    "\1\2\1\u0198\5\3\1\0\1\7\2\0\6\3\6\0"+
    "\5\3\1\u0199\3\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\5\3\1\u019a\3\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\23\3\1\u019b\12\3\1\2\6\3\1\0"+
    "\1\7\2\0\5\3\1\u019c\6\0\11\3\23\0\36\3"+
    "\1\0\5\263\10\0\2\263\13\0\5\263\23\0\1\263"+
    "\1\0\1\263\15\0\1\263\6\0\1\263\6\0\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\10\3\1\u019d"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\7\3\1\u019e\26\3\1\2\6\3"+
    "\1\0\1\7\2\0\6\3\6\0\4\3\1\u019f\4\3"+
    "\23\0\36\3\1\2\6\3\1\0\1\7\2\0\6\3"+
    "\6\0\11\3\23\0\3\3\1\u01a0\32\3\1\2\6\3"+
    "\1\0\1\7\2\0\5\3\1\u01a1\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\7\3\1\u01a2\1\3\23\0\36\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\20\3\1\u01a3"+
    "\15\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\34\3\1\u01a4\1\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\5\3\1\u01a5\3\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\24\3\1\u01a6\11\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\25\3\1\u01a7"+
    "\10\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\15\3\1\u01a8\20\3\1\2\6\3\1\0"+
    "\1\7\2\0\4\3\1\u01a9\1\3\6\0\11\3\23\0"+
    "\36\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\1\3\1\u01aa\34\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\30\3\1\u01ab"+
    "\5\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\11\3\23\0\16\3\1\u01ac\17\3\1\2\6\3\1\0"+
    "\1\7\2\0\6\3\6\0\11\3\23\0\23\3\1\u01ad"+
    "\12\3\1\2\6\3\1\0\1\7\2\0\6\3\6\0"+
    "\10\3\1\u01ae\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\26\3\1\u01af\7\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\4\3"+
    "\1\u01b0\4\3\23\0\36\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\5\3\1\u01b1\3\3\23\0\36\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\11\3"+
    "\23\0\17\3\1\u01b2\16\3\1\2\6\3\1\0\1\7"+
    "\2\0\6\3\6\0\11\3\23\0\22\3\1\u01b3\13\3"+
    "\1\2\6\3\1\0\1\7\2\0\6\3\6\0\10\3"+
    "\1\u01b4\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\7\3\1\u01b5\1\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\5\3\1\u01b6"+
    "\3\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\24\3\1\u01b7\11\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\5\3\1\u01b8"+
    "\3\3\23\0\36\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\11\3\23\0\24\3\1\u01b9\11\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\27\3\1\u01ba\6\3\1\2\6\3\1\0\1\7\2\0"+
    "\6\3\6\0\1\3\1\u01bb\7\3\23\0\36\3\1\2"+
    "\6\3\1\0\1\7\2\0\6\3\6\0\11\3\23\0"+
    "\30\3\1\u01bc\5\3";

  private static int [] zzUnpackTrans() {
    int [] result = new int[27621];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\30\1\10\11\4\1\3\11\41\1\1\11\16\1"+
    "\1\0\1\11\1\1\1\11\2\1\6\11\11\1\2\11"+
    "\1\1\1\11\1\1\6\11\34\1\1\0\3\1\1\0"+
    "\22\1\1\0\1\11\17\1\1\11\1\0\2\11\1\0"+
    "\2\11\1\1\1\11\60\1\1\11\1\1\1\0\2\1"+
    "\1\11\6\1\1\11\54\1\1\0\1\11\47\1\1\0"+
    "\34\1\1\0\25\1\1\0\61\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[444];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the textposition at the last state to be included in yytext */
  private int zzPushbackPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /* user code: */
    private int lastToken;
    private int nextState=YYINITIAL;
    
    /** 
     * next Token method that allows you to control if whitespace and comments are
     * returned as tokens.
     */
    public Token getNextToken(boolean returnComments, boolean returnWhiteSpace)throws IOException{
        Token t = getNextToken();
        while (t != null && ((!returnWhiteSpace && t.isWhiteSpace()) || (!returnComments && t.isComment()))){
            t = getNextToken();
        }
        return (t); 
    }
        
    /**
     * Prints out tokens from a file or System.in.
     * If no arguments are given, System.in will be used for input.
     * If more arguments are given, the first argument will be used as
     * the name of the file to use as input
     *
     * @param args program arguments, of which the first is a filename
     */
    public static void main(String[] args) {
        InputStream in;
        try {
            if (args.length > 0){
                File f = new File(args[0]);
                if (f.exists()){
                    if (f.canRead()){
                        in = new FileInputStream(f);
                    } else {
                        throw new IOException("Could not open " + args[0]);
                    }
                } else {
                    throw new IOException("Could not find " + args[0]);
                }
            } else {
                in = System.in;
            }
            JavaCCLexer shredder = new JavaCCLexer(in);
            Token t;
            while ((t = shredder.getNextToken()) != null) {
                if (t.getID() != JavaCCToken.WHITE_SPACE){
                    System.out.println(t);
                }
            }
        } catch (IOException e){
            System.out.println(e.getMessage());
        }
    }  

    /**
     * Closes the current input stream, and resets the scanner to read from a new input stream.
	 * All internal variables are reset, the old input stream  cannot be reused
	 * (content of the internal buffer is discarded and lost).
	 * The lexical state is set to the initial state.
     * Subsequent tokens read from the lexer will start with the line, char, and column
     * values given here.
     *
     * @param reader The new input.
     * @param yyline The line number of the first token.
     * @param yychar The position (relative to the start of the stream) of the first token.
     * @param yycolumn The position (relative to the line) of the first token.
     * @throws IOException if an IOExecption occurs while switching readers.
     */
    public void reset(java.io.Reader reader, int yyline, int yychar, int yycolumn) throws IOException{
        yyreset(reader);
        this.yyline = yyline;
		this.yychar = yychar;
		this.yycolumn = yycolumn;
	}


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public JavaCCLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public JavaCCLexer(java.io.InputStream in) {
    this(new java.io.InputStreamReader(in));
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzPushbackPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzCurrentPos*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = zzReader.read(zzBuffer, zzEndRead,
                                            zzBuffer.length-zzEndRead);

    if (numRead < 0) {
      return true;
    }
    else {
      zzEndRead+= numRead;
      return false;
    }
  }

    
  /**
   * Closes the input stream.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = zzPushbackPos = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public Token getNextToken() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      for (zzCurrentPosL = zzStartRead; zzCurrentPosL < zzMarkedPosL;
                                                             zzCurrentPosL++) {
        switch (zzBufferL[zzCurrentPosL]) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          zzR = false;
          break;
        case '\r':
          yyline++;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
          }
          break;
        default:
          zzR = false;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      zzState = zzLexicalState;


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL)
            zzInput = zzBufferL[zzCurrentPosL++];
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = zzBufferL[zzCurrentPosL++];
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          int zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
        case 91: 
          { lastToken = JavaCCToken.RESERVED_WORD_BREAK;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 135: break;
        case 119: 
          { lastToken = JavaCCToken.RESERVED_WORD_STRICTFP;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 136: break;
        case 60: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_OR_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 137: break;
        case 16: 
          { lastToken = JavaCCToken.SEPARATOR_RBRACE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 138: break;
        case 123: 
          { lastToken = JavaCCToken.RESERVED_WORD_TRANSIENT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 139: break;
        case 101: 
          { lastToken = JavaCCToken.RESERVED_WORD_WHILE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 140: break;
        case 34: 
          { Double d;
    try {
        d = Double.valueOf(yytext());
        if (d.isInfinite() || d.compareTo(new Double(0d)) == 0){
            lastToken = JavaCCToken.ERROR_DOUBLE_SIZE;
        } else {
            lastToken = JavaCCToken.LITERAL_DOUBLE;
        }
    } catch (NumberFormatException e){
        lastToken = JavaCCToken.ERROR_DOUBLE_SIZE;
    } 
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 141: break;
        case 83: 
          { lastToken = JavaCCToken.RESERVED_WORD_ELSE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 142: break;
        case 118: 
          { lastToken = JavaCCToken.RESERVED_WORD_ABSTRACT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 143: break;
        case 110: 
          { lastToken = JavaCCToken.RESERVED_WORD_PUBLIC;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 144: break;
        case 98: 
          { lastToken = JavaCCToken.RESERVED_WORD_CLASS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 145: break;
        case 23: 
          { lastToken = JavaCCToken.OPERATOR_LESS_THAN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 146: break;
        case 44: 
          { lastToken = JavaCCToken.ERROR_UNCLOSED_COMMENT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 147: break;
        case 37: 
          { lastToken = JavaCCToken.LITERAL_DOUBLE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 148: break;
        case 54: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_RIGHT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 149: break;
        case 36: 
          { /* catch the case of a zero in parsing, so that we do not incorrectly
     * give an error that a number was rounded to zero
     */
    lastToken = JavaCCToken.LITERAL_FLOATING_POINT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 150: break;
        case 4: 
          { lastToken = JavaCCToken.WHITE_SPACE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 151: break;
        case 61: 
          { lastToken = JavaCCToken.OPERATOR_LOGICAL_OR;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 152: break;
        case 82: 
          { lastToken = JavaCCToken.RESERVED_WORD_LONG;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 153: break;
        case 30: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_XOR;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 154: break;
        case 18: 
          { lastToken = JavaCCToken.SEPARATOR_RBRACKET;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 155: break;
        case 74: 
          { lastToken = JavaCCToken.RESERVED_WORD_INT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 156: break;
        case 81: 
          { lastToken = JavaCCToken.COMMENT_DOCUMENTATION;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 157: break;
        case 29: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_OR;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 158: break;
        case 133: 
          { lastToken = JavaCCToken.RESERVED_WORD_SPECIAL_TOKEN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 159: break;
        case 132: 
          { lastToken = JavaCCToken.RESERVED_WORD_PARSER_BEGIN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 160: break;
        case 35: 
          { /* An Octal number cannot be too big.  After removing 
     * initial zeros, It can have 11 digits, the first
     * of which must be 3 or less.
     */
    lastToken = JavaCCToken.LITERAL_INTEGER_OCTAL;
    int i;     
    String text = yytext();
    int length = text.length();
    for (i=1 ; i<length-11; i++){
        //check for initial zeros
        if (yytext().charAt(i) != '0'){ 
            lastToken = JavaCCToken.ERROR_INTEGER_OCTAL_SIZE;
        }
    }
    if (length - i > 11){
        lastToken = JavaCCToken.ERROR_INTEGER_OCTAL_SIZE;
    } else if (length - i == 11){
        // if the rest of the number is as big as possible
        // the first digit can only be 3 or less
        if (text.charAt(i) != '0' && text.charAt(i) != '1' && 
        text.charAt(i) != '2' && text.charAt(i) != '3'){
            lastToken = JavaCCToken.ERROR_INTEGER_OCTAL_SIZE;
        }
    }
    // Otherwise, it should be OK  
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 161: break;
        case 88: 
          { lastToken = JavaCCToken.RESERVED_WORD_VOID;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 162: break;
        case 86: 
          { lastToken = JavaCCToken.RESERVED_WORD_CHAR;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 163: break;
        case 97: 
          { lastToken = JavaCCToken.RESERVED_WORD_SHORT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 164: break;
        case 50: 
          { lastToken = JavaCCToken.OPERATOR_SUBTRACT_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 165: break;
        case 117: 
          { lastToken = JavaCCToken.RESERVED_WORD_PACKAGE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 166: break;
        case 48: 
          { lastToken = JavaCCToken.OPERATOR_ADD_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 167: break;
        case 3: 
          { /* At this point, the number we found could still be too large.
     * If it is too large, we need to return an error.
     * Java has methods built in that will decode from a string
     * and throw an exception the number is too large 
     */     
    String text = yytext();
    try {
        /* bigger negatives are allowed than positives.  Thus
         * we have to be careful to make sure a neg sign is preserved
         */
        if (lastToken == JavaCCToken.OPERATOR_SUBTRACT){
            Integer.decode('-' + text);
        } else {
            Integer.decode(text);
        }
        lastToken = JavaCCToken.LITERAL_INTEGER_DECIMAL;
    } catch (NumberFormatException e){
        lastToken = JavaCCToken.ERROR_INTEGER_DECIMIAL_SIZE;
    }
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 168: break;
        case 42: 
          { lastToken = JavaCCToken.LITERAL_STRING;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 169: break;
        case 32: 
          { /* Sun s java has a few bugs here.  Their MAX_FLOAT and MIN_FLOAT do not
     * quite match the spec.  Its not far off, so we will deal.  If they fix
     * then we are fixed.  So all good.
     */ 
    Float f;
    try {
        f = Float.valueOf(yytext());
        if (f.isInfinite() || f.compareTo(new Float(0f)) == 0){
            lastToken = JavaCCToken.ERROR_FLOAT_SIZE;
        } else {
            lastToken = JavaCCToken.LITERAL_FLOATING_POINT;
        }
    } catch (NumberFormatException e){
        lastToken = JavaCCToken.ERROR_FLOAT_SIZE;
    }
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 170: break;
        case 120: 
          { lastToken = JavaCCToken.RESERVED_WORD_CONTINUE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 171: break;
        case 20: 
          { lastToken = JavaCCToken.SEPARATOR_COMMA;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 172: break;
        case 9: 
          { lastToken = JavaCCToken.OPERATOR_MULTIPLY;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 173: break;
        case 80: 
          { lastToken = JavaCCToken.ERROR_MALFORMED_STRING;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 174: break;
        case 24: 
          { lastToken = JavaCCToken.OPERATOR_LOGICAL_NOT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 175: break;
        case 105: 
          { lastToken = JavaCCToken.RESERVED_WORD_THROWS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 176: break;
        case 115: 
          { lastToken = JavaCCToken.RESERVED_WORD_OPTIONS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 177: break;
        case 95: 
          { lastToken = JavaCCToken.COMMENT_TRADITIONAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 178: break;
        case 113: 
          { lastToken = JavaCCToken.RESERVED_WORD_EXTENDS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 179: break;
        case 102: 
          { lastToken = JavaCCToken.RESERVED_WORD_TOKEN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 180: break;
        case 33: 
          { String text = yytext();
    try {
        if (lastToken == JavaCCToken.OPERATOR_SUBTRACT){
            Long.decode('-' + text.substring(0,text.length()-1));
        } else {
            Long.decode(text.substring(0,text.length()-1));
        }
        lastToken = JavaCCToken.LITERAL_LONG_DECIMAL;
    } catch (NumberFormatException e){  
        lastToken = JavaCCToken.ERROR_LONG_DECIMIAL_SIZE;
    }
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 181: break;
        case 75: 
          { /* A Hex long cannot be too big.  After removing 
     * initial zeros, It can have 17 digits, the last of which is
     * the L or l
     */
    lastToken = JavaCCToken.LITERAL_LONG_HEXIDECIMAL;
    int i;
    String text = yytext();
    int length = text.length();
    for (i=2 ; i<length-17; i++){
        //check for initial zeros
        if (text.charAt(i) != '0'){ 
            lastToken = JavaCCToken.ERROR_LONG_HEXIDECIMAL_SIZE;
        }
    }
    if (length - i > 17){
        lastToken = JavaCCToken.ERROR_LONG_HEXIDECIMAL_SIZE;
    }
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 182: break;
        case 28: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_AND;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 183: break;
        case 22: 
          { lastToken = JavaCCToken.OPERATOR_GREATER_THAN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 184: break;
        case 69: 
          { lastToken = JavaCCToken.LITERAL_CHARACTER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 185: break;
        case 6: 
          { lastToken = JavaCCToken.ERROR_MALFORMED_UNCLOSED_CHARACTER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 186: break;
        case 62: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_XOR_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 187: break;
        case 124: 
          { lastToken = JavaCCToken.RESERVED_WORD_LOOKAHEAD;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 188: break;
        case 103: 
          { lastToken = JavaCCToken.RESERVED_WORD_RETURN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 189: break;
        case 90: 
          { lastToken = JavaCCToken.RESERVED_WORD_MORE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 190: break;
        case 21: 
          { lastToken = JavaCCToken.OPERATOR_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 191: break;
        case 116: 
          { lastToken = JavaCCToken.RESERVED_WORD_PRIVATE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 192: break;
        case 26: 
          { lastToken = JavaCCToken.OPERATOR_QUESTION;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 193: break;
        case 13: 
          { lastToken = JavaCCToken.SEPARATOR_LPAREN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 194: break;
        case 43: 
          { lastToken = JavaCCToken.COMMENT_END_OF_LINE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 195: break;
        case 66: 
          { lastToken = JavaCCToken.RESERVED_WORD_NEW;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 196: break;
        case 87: 
          { lastToken = JavaCCToken.RESERVED_WORD_GOTO;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 197: break;
        case 31: 
          { lastToken = JavaCCToken.ERROR_FLOAT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 198: break;
        case 51: 
          { lastToken = JavaCCToken.RESERVED_WORD_DO;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 199: break;
        case 85: 
          { lastToken = JavaCCToken.RESERVED_WORD_CASE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 200: break;
        case 14: 
          { lastToken = JavaCCToken.SEPARATOR_RPAREN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 201: break;
        case 64: 
          { /* An Octal number cannot be too big.  After removing 
     * initial zeros, It can have 23 digits, the first
     * of which must be 1 or less.  The last will be the L or l
     * at the end.
     */
    lastToken = JavaCCToken.LITERAL_LONG_OCTAL;
    int i; 
    String text = yytext();
    int length = text.length();
    for (i=1 ; i<length-23; i++){
        //check for initial zeros
        if (text.charAt(i) != '0'){ 
            lastToken = JavaCCToken.ERROR_LONG_OCTAL_SIZE;
        }
    }
    if (length - i > 23){
        lastToken = JavaCCToken.ERROR_LONG_OCTAL_SIZE;
    } else if (length - i == 23){
        // if the rest of the number is as big as possible
        // the first digit can only be 3 or less
        if (text.charAt(i) != '0' && text.charAt(i) != '1'){
            lastToken = JavaCCToken.ERROR_LONG_OCTAL_SIZE;
        }
    }
    // Otherwise, it should be OK  
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 202: break;
        case 130: 
          { lastToken = JavaCCToken.RESERVED_WORD_IGNORE_CASE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 203: break;
        case 108: 
          { lastToken = JavaCCToken.RESERVED_WORD_SWITCH;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 204: break;
        case 67: 
          { lastToken = JavaCCToken.RESERVED_WORD_FOR;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 205: break;
        case 129: 
          { lastToken = JavaCCToken.RESERVED_WORD_PARSER_END;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 206: break;
        case 19: 
          { lastToken = JavaCCToken.SEPARATOR_SEMICOLON;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 207: break;
        case 11: 
          { lastToken = JavaCCToken.OPERATOR_SUBTRACT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 208: break;
        case 121: 
          { lastToken = JavaCCToken.RESERVED_WORD_VOLATILE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 209: break;
        case 70: 
          { lastToken = JavaCCToken.RESERVED_WORD_EOF;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 210: break;
        case 94: 
          { lastToken = JavaCCToken.RESERVED_WORD_THROW;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 211: break;
        case 84: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_RIGHT_UNSIGNED_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 212: break;
        case 99: 
          { lastToken = JavaCCToken.RESERVED_WORD_CATCH;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 213: break;
        case 89: 
          { lastToken = JavaCCToken.RESERVED_WORD_SKIP;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 214: break;
        case 12: 
          { lastToken = JavaCCToken.SEPARATOR_PERIOD;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 215: break;
        case 2: 
          { lastToken = JavaCCToken.IDENTIFIER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 216: break;
        case 68: 
          { lastToken = JavaCCToken.RESERVED_WORD_TRY;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 217: break;
        case 107: 
          { lastToken = JavaCCToken.RESERVED_WORD_STATIC;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 218: break;
        case 39: 
          { lastToken = JavaCCToken.ERROR_UNCLOSED_CHARACTER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 219: break;
        case 78: 
          { lastToken = JavaCCToken.LITERAL_BOOLEAN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 220: break;
        case 63: 
          { lastToken = JavaCCToken.RESERVED_WORD_IF;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 221: break;
        case 47: 
          { lastToken = JavaCCToken.OPERATOR_INCREMENT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 222: break;
        case 125: 
          { lastToken = JavaCCToken.RESERVED_WORD_INTERFACE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 223: break;
        case 71: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_RIGHT_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 224: break;
        case 109: 
          { lastToken = JavaCCToken.RESERVED_WORD_IMPORT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 225: break;
        case 27: 
          { lastToken = JavaCCToken.OPERATOR_COLON;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 226: break;
        case 104: 
          { lastToken = JavaCCToken.RESERVED_WORD_NATIVE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 227: break;
        case 114: 
          { lastToken = JavaCCToken.RESERVED_WORD_DEFAULT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 228: break;
        case 131: 
          { lastToken = JavaCCToken.RESERVED_WORD_SYNCHRONIZED;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 229: break;
        case 79: 
          { lastToken = JavaCCToken.RESERVED_WORD_THIS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 230: break;
        case 49: 
          { lastToken = JavaCCToken.OPERATOR_DECREMENT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 231: break;
        case 52: 
          { lastToken = JavaCCToken.OPERATOR_EQUAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 232: break;
        case 25: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_COMPLIMENT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 233: break;
        case 5: 
          { lastToken = JavaCCToken.OPERATOR_MOD;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 234: break;
        case 100: 
          { lastToken = JavaCCToken.RESERVED_WORD_CONST;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 235: break;
        case 127: 
          { lastToken = JavaCCToken.RESERVED_WORD_INSTANCEOF;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 236: break;
        case 92: 
          { lastToken = JavaCCToken.RESERVED_WORD_FLOAT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 237: break;
        case 7: 
          { /* most of these errors have to be caught down near the end of the file.
     * This way, previous expressions of the same length have precedence.
     * This is really useful for catching anything bad by just allowing it 
     * to slip through the cracks. 
     */ 
    lastToken = JavaCCToken.ERROR_UNCLOSED_STRING;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 238: break;
        case 1: 
          { lastToken = JavaCCToken.ERROR_IDENTIFIER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 239: break;
        case 76: 
          { lastToken = JavaCCToken.LITERAL_NULL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 240: break;
        case 59: 
          { lastToken = JavaCCToken.OPERATOR_LOGICAL_AND;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 241: break;
        case 17: 
          { lastToken = JavaCCToken.SEPARATOR_LBRACKET;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 242: break;
        case 128: 
          { lastToken = JavaCCToken.RESERVED_WORD_IMPLEMENTS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 243: break;
        case 57: 
          { lastToken = JavaCCToken.OPERATOR_NOT_EQUAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 244: break;
        case 58: 
          { lastToken = JavaCCToken.OPERATOR_BITWISE_AND_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 245: break;
        case 53: 
          { lastToken = JavaCCToken.OPERATOR_GREATER_THAN_OR_EQUAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 246: break;
        case 40: 
          { lastToken = JavaCCToken.ERROR_MALFORMED_CHARACTER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 247: break;
        case 41: 
          { lastToken = JavaCCToken.ERROR_MALFORMED_UNCLOSED_STRING;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 248: break;
        case 56: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_LEFT;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 249: break;
        case 45: 
          { lastToken = JavaCCToken.OPERATOR_DIVIDE_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 250: break;
        case 15: 
          { lastToken = JavaCCToken.SEPARATOR_LBRACE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 251: break;
        case 106: 
          { lastToken = JavaCCToken.RESERVED_WORD_DOUBLE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 252: break;
        case 112: 
          { lastToken = JavaCCToken.RESERVED_WORD_FINALLY;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 253: break;
        case 55: 
          { lastToken = JavaCCToken.OPERATOR_LESS_THAN_OR_EQUAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 254: break;
        case 10: 
          { lastToken = JavaCCToken.OPERATOR_ADD;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 255: break;
        case 38: 
          { lastToken = JavaCCToken.OPERATOR_MOD_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 256: break;
        case 72: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_RIGHT_UNSIGNED;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 257: break;
        case 46: 
          { lastToken = JavaCCToken.OPERATOR_MULTIPLY_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 258: break;
        case 73: 
          { lastToken = JavaCCToken.OPERATOR_SHIFT_LEFT_ASSIGN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 259: break;
        case 65: 
          { /* A Hex number cannot be too big.  After removing 
     * initial zeros, It can have 8 digits
     */
    lastToken = JavaCCToken.LITERAL_INTEGER_HEXIDECIMAL;
    int i;    
    String text = yytext();
    int length = text.length();
    for (i=2 ; i<length-8; i++){
        //check for initial zeros
        if (text.charAt(i) != '0'){ 
            lastToken = JavaCCToken.ERROR_INTEGER_HEXIDECIMAL_SIZE;
        }
    }
    if (length - i > 8){
        lastToken = JavaCCToken.ERROR_INTEGER_HEXIDECIMAL_SIZE;
    }
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 260: break;
        case 134: 
          { lastToken = JavaCCToken.RESERVED_WORD_TOKEN_MGR_DECLS;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 261: break;
        case 111: 
          { lastToken = JavaCCToken.RESERVED_WORD_BOOLEAN;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 262: break;
        case 126: 
          { lastToken = JavaCCToken.RESERVED_WORD_PROTECTED;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 263: break;
        case 93: 
          { lastToken = JavaCCToken.RESERVED_WORD_FINAL;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 264: break;
        case 96: 
          { lastToken = JavaCCToken.RESERVED_WORD_SUPER;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 265: break;
        case 77: 
          { lastToken = JavaCCToken.RESERVED_WORD_BYTE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 266: break;
        case 8: 
          { lastToken = JavaCCToken.OPERATOR_DIVIDE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 267: break;
        case 122: 
          { lastToken = JavaCCToken.RESERVED_WORD_JAVACODE;
    String text = yytext();
    JavaCCToken t = (new JavaCCToken(lastToken,text,yyline,yychar,yychar+text.length(),nextState));
    return (t);
          }
        case 268: break;
        default: 
          if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
            zzAtEOF = true;
            return null;
          } 
          else {
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
