/*
 * 
 * @author Manuel Parras  
 */
package proyecto.utilidades;

import java.io.File;
import java.io.IOException;

import org.apache.log4j.Logger;

/**
 * Hebra
 * <p>
 * Clase que extiende a java Threard para optimizar el proceso de compilacin de
 * nuestro editor. Abre un proceso para la llamada a java para su ejecucin del
 * fichero .class. Cuando la compilacin ha sido satisfactoria.
 * </p>
 * <p>
 * La llamada al proceso se realiza con la siguiente estructura: java 
 * -classpath  aFicheroPadre aFicheroSinExtension </p>
 * 
 * @see java.lang.Thread
 */
public class HebraEjecucion extends Thread {
	
	/** The Constant objLogger. */
	private static final Logger objLogger = Logger.getLogger( HebraEjecucion.class );	
	
	/** The a fichero. */
	File aFichero;
		
		/**
		 * Constructor hebra.
		 * 
		 * Creado : Parras, 12-oct-2009
		 * 
		 * @param aArgumento
		 *            fichero a compilar
		 */
		public HebraEjecucion(File aArgumento){
			aFichero=aArgumento;	
		}
		
		/* (non-Javadoc)
		 * @see java.lang.Thread#run()
		 */
		public void run () {
			
				StringBuffer comando = new StringBuffer();
				comando.append("java ")
				.append("-classpath ").append(aFichero.getParent())
				.append(" ").append(OperacionesFicheros.getNombreSinExtension(aFichero));	  



//				se ejecuta el comando

				//Runtime lrRun = Runtime.getRuntime();
				if ( objLogger.isDebugEnabled() )
		            objLogger.debug("Compilacion Java:  " +"cmd /c start "+comando.toString() );

				


				try{


					Runtime rt = Runtime.getRuntime();
					// Process p = rt.exec("cmd /c start "+comando.toString());
					rt.exec("cmd /c start "+comando.toString());
				} catch (IOException e) {					
					Mensajes.mensajeDetalles("Error al lanzar la consola.", e);

				}
				
				}
		
	}


