package proyecto.utilidades;


//Importaciones
//---------------------------------------------------------------------------
import java.awt.Font;

import javax.swing.plaf.FontUIResource;



/**
*	Clase que contiene el StyleSheet (hoja de estilo CSS en formato java) para los
*	documentos HTML EpSilon. La clase implementa el patrn Singleton ya que no se debe necesitar
*	ms de una instancia de la misma.
*	Modo de uso: Para utilizarla se reproducir el siquiente cdigo : <BR>
*	HTMLEditorKit kit = new HTMLEditorKit(); <BR>
*	kit.setStyleSheet(HojaEstilo.get()); <BR>
*	textPane.setEditorKit(kit);  <BR>
*	<BR>
*	de este modo conseguimos aplicar la hoja de estilo nicamente al documento que queremos
*	si nos limitamos a hacer: <BR>
*	textPane.getEditorKit().setStyleSheet(HojaEstilo.get()) <BR>
*	cambiaremos la hoja de estilo del editor kit por defecto con lo que todos los JTextPane con HTML la utilizarn. <BR>
*
*	
*/

public class HojaEstilo extends javax.swing.text.html.StyleSheet {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7707925434748953776L;
	public static HojaEstilo hoja = new HojaEstilo();

	/** Constructor HojaEstilo */
 private HojaEstilo() {
	javax.swing.plaf.FontUIResource fuenteDefecto=new FontUIResource(new Font("Arial",Font.BOLD,12));
	
		String reglaTamanoFuente = new StringBuffer().append("body { font-size : ")
				.append(fuenteDefecto.getSize())
				.append("pt; }").toString();
		
		java.awt.Color colorTexto = java.awt.Color.black;
		String colorHex = toHexString(colorTexto);
		String reglaColor = new StringBuffer().append("body { color : #")
				.append(colorHex).toString();

		String reglaFuente = new StringBuffer().append("body { font-family :")
				.append(fuenteDefecto.getFamily()).append("; }").toString();

		//Reglas para el texto por defecto
		this.addRule(reglaColor);
		this.addRule(reglaTamanoFuente);
		this.addRule(reglaFuente);

//a:visited {
// color: something;
// }
//a:active {
// color: something;
// }
//a:hover {
// color: something;
// }
			colorHex = toHexString(0,0,204);
			reglaColor = new StringBuffer().append("a { color: #")
					.append(colorHex).append(";}").toString();
			 this.addRule(reglaColor);
			 //this.addRule(" a { color: #12345;}");
			 this.addRule(" a { text-decoration: underline } ");
			 //this.addRule(" a {font-weight: bold }");

			 //this.addRule(" a:hover{ color: green;}");
			//this.addRule("A:link    { color: red; }");
          //this.addRule("a:active  { color: green; font-size: 125% }");
          //this.addRule(" a:visited { color: yellow; font-size: 85	");
 }

	public static HojaEstilo get(){
		return hoja;
	}

//	private static void main (String [] args){
//		javax.swing.JTextPane jtp = new javax.swing.JTextPane();
//		jtp.setContentType("text/html");
//		javax.swing.text.html.HTMLEditorKit kit = (HTMLEditorKit)jtp.getEditorKit();
//		//javax.swing.text.html.HTMLEditorKit kit = new javax.swing.text.html.HTMLEditorKit();
//		javax.swing.text.html.HTMLDocument doc = (javax.swing.text.html.HTMLDocument) kit.createDefaultDocument();
//
//		StyleSheet styles = doc.getStyleSheet();
//
//		styles.getDefaultStyleContext()
//		java.util.Enumeration rules = styles.getStyleNames();
//		while (rules.hasMoreElements()) {
//		   String name = (String) rules.nextElement();
//		   javax.swing.text.Style rule = styles.getStyle(name);
//		   System.out.println(rule.getName());
//		}
//		System.exit(0);
//	 }


	

	/**
	 * 
	 * <p> Devuelve el string hexadecimal que representa un color a partir de los componentes RGB</p>
	 * 
	 * @param rojo  componente rojo del color.
	 * @param verde componente verde del color.
	 * @param azul  componente azul del color.  
	 * @return String Cadena que representa el hexadecimal del color que llega como parmetro
	 */
	public static String toHexString(int rojo, int verde, int azul){
        String red = Integer.toHexString(rojo);
        String green = Integer.toHexString(verde);
        String blue = Integer.toHexString(azul);
        
        if (red.length() != 2 )
                red = "0" + red;
        if (green.length() != 2 )
                green = "0" + green;
        if (blue.length() != 2 )
                blue = "0" + blue;

        return red + green + blue;
		
	}
	
	
	 /**
	 * Devuelve el string hexadecimal que representa un color a partir del
	 * mismo.
	 * 
	 * @param c
	 *            , color para el que se va a obtener el valor hexadecimal.
	 * @return String , Cadena que representa el hexadecimal del color que llega
	 *         como parmetro
	 */
	public static String toHexString(java.awt.Color c) {
		return toHexString(c.getRed(), c.getGreen(), c.getBlue());
	}
}
