/*
 * 
 * @author Manuel Parras  
 */
package proyecto.utilidades;


import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;
import proyecto.consola.ConsolaTextPane;

/** 
 * MenuPopupConsola.java
 * 
 * Esta clase es la encargada de pintarnos nuestro men contextual cuando
 * pulsemos con el botn derecho del ratn sobre una pestaa de la consola.<br>
 * La opciones que no despliegan son :
 * <ul> 
 * <li>tem Copiar: Cuando nos referimos a copiar queremos decir que vamos a
 * situar el contenido de texto en portapapeles.
 * 
 * <li>tem Cortar: Cuando hablamos de cortar queremos decir quitar algo de un
 * lugar para llevarlo a otro lugar.
 * 
 * <li>tem Pegar: Si seleccionamos esta opcin la cantidad de texto que
 * tengamos en el Portapapeles se introducir en nuestro componente de texto.
 * 
 * <li>tem Seleccionar todo: Nos marca todo el texto que existe dentro de
 * nuestro componente.
 * 
 * <li>tem Suprimir cdigo:Elimina la seleccin de texto seleccionada.
 * </ul>
 * Si deseamos ampliar con alguna opcin ms nuestro men contextual, debemos
 * definir el JMenuItem y en el mtodo getPopupMenu() se crear y se dir la
 * accin que debe realizar.<br>
 * Si necesitamos algn regla de negocio para la visibilidad del tem se realiza
 * en el mtodo isVisible().
 * 
 *@author mparras
 */
 
public class MenuPopupConsola extends MouseAdapter {
    
/**item menu.  */
private JMenuItem itemMenuEditar_Copiar,itemMenuEditar_Pegar;

/**  item menu */
private JMenuItem itemMenuEditar_Cortar,itemMenuEditar_Todo,itemMenuEditar_Supr;

	
      

         /**MenuCacheado. */
         private JPopupMenu cachedMenu = null;
         
         /** itexto. 
          * @see proyecto.consola.ConsolaTextPane*/
         private ConsolaTextPane iTexto;
        

         /**
			 * Constructor menu popup consola.
			 * 
			 * Creado : Parras, 12-oct-2009
			 */
         public MenuPopupConsola () {
         	
         }
         
         /**
			 * Constructor menu popup consola.
			 * 
			 * Creado : Parras, 12-oct-2009
			 * 
			 * @param aTexto
			 *            the a texto
			 */
         public MenuPopupConsola (ConsolaTextPane aTexto) {
        	 iTexto =aTexto;
         }
         




         /* (non-Javadoc)
          * @see java.awt.event.MouseAdapter#mousePressed(java.awt.event.MouseEvent)
          */
         public void mousePressed(MouseEvent ev) {


             activarPopup(ev);


         }

       
         /* (non-Javadoc)
          * @see java.awt.event.MouseAdapter#mouseReleased(java.awt.event.MouseEvent)
          */
         public void mouseReleased(MouseEvent ev) {

             activarPopup(ev);

         }



         /* (non-Javadoc)
          * @see java.awt.event.MouseAdapter#mouseClicked(java.awt.event.MouseEvent)
          */
         public void mouseClicked(MouseEvent ev) {


             activarPopup(ev);

         }

         /**
			 * Activar popup. Creado : Parras, 12-oct-2009
			 * 
			 * @param ev
			 *            the ev
			 */
         private void activarPopup(MouseEvent ev) {

             if (ev.isPopupTrigger()) {


                 JPopupMenu menu = getPopupMenu();


                 menu.pack();
                 menu.show((Component)ev.getSource(), ev.getX(), ev.getY());


             }


         }

         /**
			 * Obtener el popup menu.
			 * 
			 * @return el popup menu Creado : Parras, 12-oct-2009
			 */
         private JPopupMenu getPopupMenu() {
             JPopupMenu menu = cachedMenu;
             if (menu == null) {
                 menu = new JPopupMenu();            

             	

             	//	ITEM COPIAR ctrl+C
             	itemMenuEditar_Copiar = new JMenuItem("Copiar");
             	itemMenuEditar_Copiar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
             	itemMenuEditar_Copiar.addActionListener (
            			new ActionListener () {
            				public void actionPerformed (ActionEvent e) {
            					iTexto.copiar();
            				}
            			});
             	menu.add(itemMenuEditar_Copiar);

             	//	ITEM Pegar ctrl+V
             	itemMenuEditar_Pegar = new JMenuItem("Pegar");
             	itemMenuEditar_Pegar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, ActionEvent.CTRL_MASK));
             	itemMenuEditar_Pegar.addActionListener (
            			new ActionListener () {
            				public void actionPerformed (ActionEvent e) {
            					iTexto.pegar();
            				}
            			});
             	
             	menu.add(itemMenuEditar_Pegar);

             	//	ITEM Cortar  ctrl+x
             	itemMenuEditar_Cortar = new JMenuItem("Cortar");
             	itemMenuEditar_Cortar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
             	itemMenuEditar_Cortar.addActionListener (
            			new ActionListener () {
            				public void actionPerformed (ActionEvent e) {
            					iTexto.cortar();
            				}
            			});
             	
             	menu.add(itemMenuEditar_Cortar);
             	
             	
             	menu.addSeparator();

             	//	ITEM Suprimir SUPR
             	itemMenuEditar_Supr = new JMenuItem("Borrar");
             	itemMenuEditar_Supr.setMnemonic('l');
             	itemMenuEditar_Supr.setDisplayedMnemonicIndex(2); 
             	itemMenuEditar_Supr.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
             	itemMenuEditar_Supr.addActionListener (
            			new ActionListener () {
            				public void actionPerformed (ActionEvent e) {
            					iTexto.limpiarTexto();
            				}
            			});
             	
             	menu.add(itemMenuEditar_Supr);
             	

             	//	ITEM Seleciona Todo ctr+A
             	itemMenuEditar_Todo = new JMenuItem("Selecionar todo ");
             	itemMenuEditar_Todo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
             	itemMenuEditar_Todo.addActionListener (
            			new ActionListener () {
            				public void actionPerformed (ActionEvent e) {
            					iTexto.selecionarTodo();
            				}
            			});
             	menu.add(itemMenuEditar_Todo);


      
                 
             }

             return menu;

         }
	 


 }

