/*
 * 
 * @author Manuel Parras  
 */
package proyecto.utilidades;
/*
 * CopiarFicheros.java
 *
 * Created on 3 de mayo de 2007, 13:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;

import javax.swing.text.BadLocationException;

import proyecto.editor.EpSilonExcepciones;



// TODO: Auto-generated Javadoc
/**
 * OperacionesFicheros.
 * <p>
 * Clase con mtodos estaticos para operaciones b�sicas con ficheros, por
 * ejemplo:
 * 
 * <ul>
 * <li>Copiar directorio: copyDirectorio</li>
 * <li>Borrar directorio : deleteDirectorio</li>
 * <li>ect..</li>
 * </ul>
 * </p>
 * 
 * @author mparras
 */


public class OperacionesFicheros{

	/**
	 * Copia un directorio con todo y su contendido.
	 * 
	 * @param srcDir
	 *            src dir
	 * @param dstDir
	 *            dst dir
	 * 
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	public static void copyDirectorio(File srcDir, File dstDir) throws IOException {
		int cont=0;
		String[] children=null;
		// System.out.println("Origen: "+srcDir+ " Destino :"+dstDir+" Lo que monto "+srcDir+File.separator+srcDir.getName());
		if (!dstDir.toString().equals(srcDir+File.separator+srcDir.getName())){
			//System.out.println("MISMO DIRECTORIOOOOOO");

			if (srcDir.isDirectory()) {
				if (!dstDir.exists()) {
					dstDir.mkdir();
				}
//				if (dstDir.toString().equals(srcDir+File.separator+srcDir.getName()) ){
//				Filtro filtro =new Filtro(srcDir.getName());
//				// children = srcDir.list(filtro.accept(dstDir)));
//				}else{  
				children = srcDir.list();
//				}



				for (int i=0; i<(children.length-cont); i++) {
					copyDirectorio(new File(srcDir, children[i]),
							new File(dstDir, children[i]));
				}
			} else {
				copy(srcDir, dstDir);
			}
		}else
			Mensajes.mensajeAtencion("No se puede copiar carpeta dentro de si misma");

	}
	
	
	
	/**
	 * Valida un string, para montar Nombres validos.
	 * 
	 * @param lsFileName
	 *            the ls file name
	 * 
	 * @return true, if validador file name
	 */
	public static boolean validadorFileName (String lsFileName){
		//[a-zA-Z$_0-9]*
		boolean valido=false;
		if (lsFileName!=null)
			valido=lsFileName.matches("[a-zA-Z$_0-9 ]*");

		return valido;
	}


	/**
	 * Copia un solo archivo.
	 * 
	 * @param src
	 *            the src
	 * @param dst
	 *            the dst
	 * 
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	public static void copy(File src, File dst) throws IOException {
		InputStream in = new FileInputStream(src);
		OutputStream out = new FileOutputStream(dst);


		byte[] buf = new byte[1024];
		int len;
		while ((len = in.read(buf)) > 0) {
			out.write(buf, 0, len);
		}
		in.close();
		out.close();
	}
	//Borra todo las fichero de un directorio
	// Devuelve cierto si se borra.    
	/**
	 * Delete directorio.
	 * 
	 * @param dir
	 *            the dir
	 * 
	 * @return true, si es correcto Creado : Parras, 07-oct-2009
	 */
	public static boolean deleteDirectorio(File dir) {
		if (dir.isDirectory()) {
			String[] hijos = dir.list();
			for (int i=0; i<hijos.length; i++) {
				boolean ok = deleteDirectorio(new File(dir, hijos[i]));
				if (!ok) {
					return false;
				}
			}
		}

		// El directorio esta vacio o no se puede borrar        
		return dir.delete();
	}
	
	
	/**
	 * Borra de un directorio todas las extensiones que pasemos por parametros.
	 * 
	 * @param directory
	 *            directory
	 * @param extension
	 *            xtension
	 * 
	 * @author Creado : Parras, 21-feb-2010
	 */
	public static void deleteFiles( String directory, String extension ) {
		Filtro filter = new Filtro(extension);
	    File dir = new File(directory);

	    String[] list = dir.list(filter);
	    File file;
	    if (list.length == 0) return;

	    for (int i = 0; i < list.length; i++) {
	      //file = new File(directory + list[i]);
	      file = new File(directory, list[i]);
	      file.delete();
	    }
	   }
	
	/**
	 * Delete files por java cc. Creado : Parras, 21-feb-2010
	 * 
	 * @param directory
	 *            the directory
	 * @param extension
	 *            the extension
	 */
	public static void deleteFilesPorJavaCC( String directory, String extension ) {
		EliminarFicheroJavaCC filter = new EliminarFicheroJavaCC(extension);
	    File dir = new File(directory);

	    String[] list = dir.list(filter);
	    File file;
	    if (list.length == 0) return;

	    for (int i = 0; i < list.length; i++) {
	      //file = new File(directory + list[i]);
	      file = new File(directory, list[i]);
	      file.delete();
	    }
	   }
	
	  


	/**
	 * Filtro.
	 */
	public static  class Filtro implements FilenameFilter{
		
		/** The extension. */
		String extension;
		
		/**
		 * Constructor filtro.
		 * 
		 * Creado : Parras, 07-oct-2009
		 * 
		 * @param extension
		 *            the extension
		 */
		Filtro(String extension){
			this.extension=extension;
		}
		
		/* (non-Javadoc)
		 * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
		 */
		public boolean accept(File dir, String name){
			return name.endsWith(extension);
		}
	}
	
/**
 * Clase que nos devuelve de un directirio los ficheros que 
 * han sido generados por javaCC
 */
public static  class EliminarFicheroJavaCC implements FilenameFilter{
		 
		 ArrayList<String> iFicherosGenerados ;
		
		/**
		 * Constructor eliminar fichero java cc.
		 * 
		 * Creado : Parras, 21-feb-2010
		 * 
		 * @param aNombreFicheroMain
		 *            the a nombre fichero main
		 */
		public  EliminarFicheroJavaCC(String aNombreFicheroMain){
			
			iFicherosGenerados= new ArrayList<String>();
			//generados por el nombre del fichero
			iFicherosGenerados.add(aNombreFicheroMain+".java");
			iFicherosGenerados.add(aNombreFicheroMain+"Constants.java");//TokenManager
			iFicherosGenerados.add(aNombreFicheroMain+"TokenManager.java");
			//generados automaticamente por javaCC
			iFicherosGenerados.add("Token.java");
			iFicherosGenerados.add("TokenMgrError.java");
			iFicherosGenerados.add("ParseException.java");
			iFicherosGenerados.add("SimpleCharStream.java");
			
			
		}
		
		/* (non-Javadoc)
		 * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
		 */
		public boolean accept(File dir, String name){
			
			
			return iFicherosGenerados.contains(name);
		}
	}


	/**
	 * Guarda un Fichero con un texto en la zona indicada.
	 * 
	 * @param archivo
	 *            the archivo
	 * @param aTexto
	 *            the a texto
	 * 
	 * @throws EpSilonExcepciones
	 *             the excepciones
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */


	public  static void guardarFichero(File archivo,String aTexto) throws EpSilonExcepciones, IOException {

		try
		{
			// Abrimos el Archivo

			//Nos Abrimos el descriptor
			FileWriter out = new FileWriter(archivo);

			out.write(aTexto);
			out.close();       

		}
		catch (EpSilonExcepciones e) {

		}

	}

	/**
	 * Devuelve la extension de un fichero dado.
	 * 
	 * @param f
	 *            File
	 * 
	 * @return the extension
	 */

	public static String getExtension(File f) {
		if(f != null) {
			String filename = f.getName();
			int i = filename.lastIndexOf('.');
			if(i>0 && i<filename.length()-1) {
				//Saltamos el punto
				return filename.substring(i+1);
			};
		}
		return null;
	}

	/**
	 * Devuelve el nombre de un fichero dado sin extensi�n.
	 * 
	 * @param f
	 *            ruta completa
	 * 
	 * @return the nombre sin extension
	 */

	public static String getNombreSinExtension(File f) {
		if(f != null) {
			String filename = f.getName();
			int i = filename.lastIndexOf('.');
			if(i>0 && i<filename.length()-1) {				
				return filename.substring(0,i);
			};
		}
		return null;
	}
	
	/**
	 * Cargar fichero.
	 * 
	 * @param nombreArchivo
	 *            the nombre archivo
	 * 
	 * @return the string Creado : Parras, 07-oct-2009
	 * 
	 * @throws BadLocationException
	 *             the bad location exception
	 */
	public  static String cargarFichero(File nombreArchivo)
	throws BadLocationException {
		try{
			// nos proporciona informaci�n acerca de los archivos, de sus
			// atributos, de los directorios

			// Obtenemos el tama�o del fichero
			int tamanno = (int) nombreArchivo.length();

			// Caracteres a leer
			int car_Leer = 0;

			// Creamos el descriptor para leer el fichero
			FileReader in = new FileReader(nombreArchivo);

			// No creamos el array del tama�o de fichero
			char[] data = new char[tamanno];

			// Empezamos a recorer el fichero miestras este preparado
			while (in.ready()) {

				car_Leer += in.read(data, car_Leer,tamanno- car_Leer);
			}
			in.close();

			// Guardamos todo lo leido de en nuestro panel		
			return new String(data, 0, car_Leer);
	} catch (IOException e) {
		Mensajes.mensajeDetalles("Error Abriendo " + nombreArchivo,e);
	}
	return "";
	}
	
} 
