/*
 * 
 * @author Manuel Parras  
 */

package proyecto.utilidades;



import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;



// TODO: Auto-generated Javadoc
/**
 * SplashPrincipal
 * <p>
 * El Splash Screen es esa pequea ventana flotante que aparece justo cuando
 * est cargando Epsilon y sobre la cual aparece una serie de informacin que
 * representan los distintos mdulos que se estn activando en ese momento.
 * </p>
 * <p>
 * Esta clase tiene todo los mtodos referentes para manejar nuestro Splash en
 * el momento de inicio de la aplicacin.
 * </p>
 * 
 * @see javax.swing.JProgressBar
 * @author Parras
 */
public class SplashPrincipal extends JWindow {

	/** The progress bar. */
	private JProgressBar progressBar;
	
	/** Hembra de nuestro splash. */
	private Thread isplashThread;
	
	/** text de la ventana. */
	private JLabel text;
	
	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor splash principal.
	 * 
	 * Creado : Parras, 13-oct-2009
	 * 
	 * @param imagenLogo
	 *            the imagen logo
	 * @param f
	 *            the f
	 * @param waitTime
	 *            the wait time
	 */
	public SplashPrincipal(Icon imagenLogo, Frame f, int waitTime)
    {
            
        super(f);
        JPanel centro = new JPanel();
        centro. setLayout(null);
        centro.setBackground(Color.WHITE);
        //TitledBorder titulo_splash = new TitledBorder(BorderFactory.createMatteBorder(4, 4, 0, 4, Color.BLUE),"");
		//centro.setBorder(titulo_splash);
        JLabel jLabelLogo = null;    
       
        text = new JLabel();
        
      
        
        
        
        
        //TitledBorder titulo_texto = new TitledBorder(BorderFactory.createMatteBorder(0, 4, 4, 4, Color.BLUE),"");
		//barra_texto.setBorder(titulo_texto);
        //barra_texto.setBackground(Color.ORANGE);
		
        jLabelLogo = new JLabel(imagenLogo);     
        //Tamao de la imagen        
        jLabelLogo.setBounds(0, 0, 510, 330);
        
        getContentPane().add(centro);
        pack();
        Dimension screenSize =
          Toolkit.getDefaultToolkit().getScreenSize();
        Dimension labelSize = jLabelLogo.getPreferredSize();
        setLocation(screenSize.width/2 - (labelSize.width/2),
                    screenSize.height/2 - (labelSize.height/2));
    setVisible(true);
    
             //----- tiempo que estara visible la ventana, en milisegundos
        final int pause = waitTime;

             //----- Este es el objeto que cierra la ventana
        final Runnable closerRunner = new Runnable()
            {
                public void run()
                {
                	killSplash();
                }
            };

            //----- Este es el objeto que pone a dormir a closerRunner
            //----- y captura las excepciones;
        Runnable waitRunner = new Runnable()
            {
                public void run()
                {
                    try
                        {
                            Thread.sleep(pause);
                            SwingUtilities.invokeAndWait(closerRunner);
                        }
                    catch(Exception e)
                        {
                            e.printStackTrace();
                            // can catch InvocationTargetException
                            // can catch InterruptedException
                        }
                }
            };
            text.setVisible(true);
            text.setOpaque(false);
            text.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            centro.add(text);
            text.setBounds(130, 303, 260, 14);
            progressBar = new JProgressBar();
            progressBar.setForeground(new java.awt.Color(255, 153, 0));
            centro.add(progressBar);
            progressBar.setBounds(10, 300, 490, 20);
            centro.add(jLabelLogo);
            //----- aqui creamos y lanzamos el hilo
         isplashThread = new Thread(waitRunner, "SplashThread");
        isplashThread.start();
    }
	//---------------------------------------------------------------------------
	
    
  
	/**
	 * killSplash este Metodo nos oculta a la hembra por si en la ejecucion
	 * tenemos que ocultar algo.
	 */
	public void killSplash(){
		 setVisible(false);
         dispose();
	}
	
	/**
	 * Para fijar la posicin y tamao de la barra de progreso.
	 * 
	 * @param x
	 *            Coordenada X.
	 * @param y
	 *            Coordenada Y.
	 * @param width
	 *            Tamao a sumar a X (anchura).
	 * @param height
	 *            Tamao a sumar a Y (altura).
	 */
	public void setProgressBarBounds(int x, int y, int width, int height) {
     	progressBar.setBounds(x, y, width, height);
    }
	//--------------------------------------------------------------------------
	/**
	 * Cabia el color de la barra de progreso.
	 * 
	 * @param color
	 *            Nuevo color.
	 */
	public void setProgressBarColor(Color color) {
		 progressBar.setForeground(color);
		 progressBar.setBackground(color);
		 
	}
	//-------------------------------------------------------------------------- 
	/**
	 * Cambia el estado de la barra de progreso.
	 * 
	 * @param vis
	 *            True/False dependiendo si queremos hacerla visible o no.
	 */
	public void setProgressBarVisible(boolean vis) {
		progressBar.setVisible(vis);
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos permite obtener la barra de progreso en s por si queremos cambiar
	 * alguna propiedad especial sobre ella que no est disponible.
	 * 
	 * @return Barra de progreso en cuestin.
	 */
	public JProgressBar getProgressBar() {
		 return progressBar;
	}
	//--------------------------------------------------------------------------
	/**
	 * Indicamos cual ser el nmero de pasos que se llevarn a cabo en la
	 * inicializacin de la aplicacin.
	 * 
	 * @param max
	 *            Mximo numero de pasos.
	 */
	public void setProgressBarMaximum(int max) {
		progressBar.setMaximum(max);
	}
	//--------------------------------------------------------------------------
	/**
	 * Inicializa el valor a partir del cual avanzaremos en la barra de
	 * progreso.
	 * 
	 * @param val
	 *            Valor inicial de la barra de progreso.
	 */
	public void setProgressBarValue(int val) {
		progressBar.setValue(val);
	}
	//--------------------------------------------------------------------------
	/**
	 * Hacemos que la barra de progreso avance tanto como le indiquemos.
	 * 
	 * @param increment
	 *            Cantidad a avanzar.
	 */
	public void incrementProgressBarValue(int increment) {
		progressBar.setValue(progressBar.getValue() + increment);
	}
	//--------------------------------------------------------------------------
	/**
	 * Para fijar la posicin y tamao de la etiqueta que se mostrara junto a la
	 * barra de progreso.
	 * 
	 * @param x
	 *            Coordenada X.
	 * @param y
	 *            Coordenada Y.
	 * @param width
	 *            Tamao a sumar a X (anchura).
	 * @param height
	 *            Tamao a sumar a Y (altura).
	 */
	public void setProgressTextBounds(int x, int y, int width, int height) {
		text.setBounds(x, y, width, height);
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos permite cambiar la fuente de la etiqueta que se mostrar junto a la
	 * barra de progreso.
	 * 
	 * @param font
	 *            Nueva fuente.
	 */
	public void setProgressTextFont(Font font) {
		text.setFont(font);
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos permite cambiar el color de la fuente para la etiqueta que se
	 * mostrar junto a la barra de progreso.
	 * 
	 * @param color
	 *            Nuevo color de la fuente.
	 */
	public void setProgressTextColor(Color color) {
		text.setForeground(color);
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos determina si se mostrara o no la etiqueta junto a la barra de
	 * progreso.
	 * 
	 * @param vis
	 *            True/False dependiendo de si queremos que se muestre o no.
	 */
	public void setProgressTextVisible(boolean vis) {
		text.setVisible(vis);
		
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos permite cambiar el texto que se visualiza en la etiqueta que va junto
	 * a la barra de progreso.
	 * 
	 * @param text
	 *            Nuevo texto de la etiqueta.
	 */
	public void setProgressText(String text) {
		this.text.setText(text);
	}
	//--------------------------------------------------------------------------
	/**
	 * Nos devuelve el texto actual que forma la etiqueta que va junto a la
	 * barra de progreso.
	 * 
	 * @return Texto actual de la etiqueta.
	 */
	public JLabel getProgressTextLabel() {
		return text;
	}

	/**
	 * The Class ImagenPanel.
	 */
	class ImagenPanel extends JPanel {

		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 1L;
		
		/** The img. */
		Image img;

		/**
		 * Constructor imagen panel.
		 * 
		 * Creado : Parras, 13-ene-2010
		 * 
		 * @param aImage
		 *            the a image
		 */
		public ImagenPanel(File f) {

			

			super();

			img =  loadImage(f);

		}

		/* (non-Javadoc)
		 * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
		 */
		public void paintComponent(Graphics g) {
			super.paintComponent(g);

			if (img != null) {

				g.drawImage(img, 0, 0, this);

			}

		}

		/**
		 * Load imagen desde archivo.
		 * 
		 * @param f
		 *           
		 * 
		 * @return  image Creado : Parras, 13-ene-2010
		 */
		public Image loadImage(File f) {

			Image image = getToolkit().getImage(f.getPath());

			return image;

		}

	}



 
	
}
