/*
 * 
 * @author Manuel Parras  
 */
package proyecto.utilidades;

import java.awt.Cursor;
import java.io.File;
import java.io.FileFilter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import javax.tools.JavaCompiler.CompilationTask;

import org.apache.log4j.Logger;

import proyecto.arbol.ArbolFicheros;
import proyecto.arbol.Nodo;
import de.hunsicker.jalopy.Jalopy;





// TODO: Auto-generated Javadoc
/**
 * UtilidadesEpsilon.
 * 
 * *
 * <p>
 * Clase con mtodos estaticos para operaciones bsicas con elementos generales
 * del entorno de desarrollo, por ejemplo:
 * </p>
 * <ul>
 * <li>Cursor en Espera: cursorEspera( panel,abModo)</li>
 * <li>Aadir Nodos Arbol :addNodos(DefaultMutableTreeNode,File dir)</li>
 * <li>ect..</li>
 * </ul>
 */
public class UtilidadesEpsilon {
	
	/** objLogger. */
	private static final Logger objLogger = Logger.getLogger( UtilidadesEpsilon.class );
	//	 Pone un cursor de espera si abModo = true y lo quita si abModo = false

	/**
	 * Cursor espera. Creado : Parras, 13-oct-2009
	 * 
	 * @param panel
	 *            panel
	 * @param abModo
	 *            modo
	 */
	public static void cursorEspera(JPanel panel, boolean abModo)

	{

		if (abModo){
			panel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

		}

		else{

			panel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		}

	}
	
	/**
	 * FormatearCodigo
	 * 
	 * Nos da el sangrado correcto de nuestro cdigo Java.
	 * 
	 * @param texto
	 *            the texto
	 * @param archivo
	 *            the archivo
	 * 
	 * @return the string
	 */
	 public static String formatearCodigo(String texto,File archivo) {
	        String input = texto;
	        StringBuffer output = new StringBuffer();
	        Jalopy jalopy = new Jalopy();
	        
	        // setup the Jalopy input/output
	        jalopy.setInput(input, archivo.getName());
	        jalopy.setOutput(output);
	        
	        // Formatear con jalopy
	        jalopy.format();
	        
	        // check the status of the format
	        if (jalopy.getState() == Jalopy.State.ERROR) {
	            // errors. this is BAD
	            Mensajes.mensajeError("Error: No se ha podido procesar este cdigo");
//	            JOptionPane.showMessageDialog(this,
//	                    "No se ha podido formatear el cdigo",
//	                    "Error: No se ha podido procesar este cdigo",
//	                    JOptionPane.ERROR_MESSAGE);
	        } else {
	            texto=output.toString();
	        }
	        return texto;
	    }
	 
	 /**
			 


	/**
	 * Compilacin java, para varios fichero de javaCC y diciendo cual es
	 * nuestro clase main para mostrarla en una ventana.
	 * 
	 * @param aDirectorioFichero
	 *            the a directorio fichero
	 * @param aNombreFicheroMain
	 *            the a nombre fichero main
	 */
	public static void compilarJava (File aDirectorioFichero,String aNombreFicheroMain){




		JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();    
		if (compiler == null) { 
			Mensajes.mensajeError("Compilador no encontrado");

		} 

		// create a collector for diagnostic messages 
		DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>(); 

		// obtain a standard manager for Java file objects 
		StandardJavaFileManager fileMan =  
			compiler.getStandardFileManager(diagnostics, null, null); 

		/* build an iterable list holding a Java file object  
		     for the supplied file */ 
		//Debemos Filtrar por files java en el directorio
		Iterable<? extends JavaFileObject> fileObjs = fileMan.getJavaFileObjectsFromFiles(Arrays.asList(aDirectorioFichero.listFiles(new MiFiltro(".java")))); 

		/* create a compilation task using the supplied file  
		     manager, diagnostic collector, and applied to the  
		     Java file object */ 
		CompilationTask tareaCompilacion= compiler.getTask(null, fileMan, diagnostics,null, null, fileObjs); 
		if (!tareaCompilacion.call()) {  // carry out the compilation 
			System.out.println("Compilation failed"); 

			for (Diagnostic d : diagnostics.getDiagnostics()) 
				System.err.println(d); 	
		}else{


			System.out.print("Compilation successfully ");


			//java -classpath E:\Util\workspace\prueba\Workspace\proyecto\Prueba\generadosNL_Xlator NL_Xlator
			StringBuffer comando = new StringBuffer();
			comando.append("java ")
			.append("-classpath ").append(aDirectorioFichero.getAbsolutePath())
			.append(" ").append(aNombreFicheroMain);	  


			if ( objLogger.isDebugEnabled() )
	            objLogger.debug("Compilacion Java:  " +"cmd /c start "+comando.toString() );

//			se ejecuta el comando

			//Runtime lrRun = Runtime.getRuntime();


			try{


				Runtime rt = Runtime.getRuntime();
				// Process p = rt.exec("cmd /c start "+comando.toString());
				rt.exec("cmd /c start "+comando.toString());

//				// Se obtiene el stream de salida del programa
//				InputStream is = p.getInputStream();

//				// Se prepara un bufferedReader para poder leer la salida ms
//				// comodamente.
//				BufferedReader br = new BufferedReader (new InputStreamReader (is));

//				// Se lee la primera linea
//				String aux = br.readLine();

//				// Mientras se haya leido alguna linea
//				while (aux!=null)
//				{
//				// Se escribe la linea en pantalla
//				System.out.println (aux);

//				// y se lee la siguiente.
//				aux = br.readLine(); 
//				}

			} catch (IOException e) {
				// TODO Bloque catch generado automticamente
				Mensajes.mensajeDetalles("Error al lanzar la consola.", e);

			}

//			//a veces da errores el comando de desplazamiento por eso se repite
//			while (p.waitFor()!= 0)
//			p = lrRun.exec("cmd.exe /c "+lsbComandoMover.toString());

		}


	}

	/**
	 * Compilacin java de un fichero java. Abriendo una hebra para ejecutar la
	 * accin
	 * 
	 * @param aDirectorioFichero
	 *            the a directorio fichero
	 * @param aOkEjecucion
	 *            si queremos que se ejecute el main true, en otro caso falso
	 * 
	 * @see proyecto.utilidades.HebraEjecucion
	 */
	public static void compilarJava (File aDirectorioFichero,boolean aOkEjecucion){




		JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();    
		if (compiler == null) { 
			Mensajes.mensajeError("Compilador no encontrado");		     
		} 

		// create a collector for diagnostic messages 
		DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>(); 

		// obtain a standard manager for Java file objects 
		StandardJavaFileManager fileMan =  
			compiler.getStandardFileManager(diagnostics, null, null); 
		

		/* build an iterable list holding a Java file object  
		     for the supplied file */ 
		//Debemos Filtrar por files java en el directorio
		Iterable<? extends JavaFileObject> fileObjs = fileMan.getJavaFileObjectsFromFiles(Arrays.asList(aDirectorioFichero)); 

		/* create a compilation task using the supplied file  
		     manager, diagnostic collector, and applied to the  
		     Java file object */ 
		CompilationTask tareaCompilacion= compiler.getTask(null, fileMan, diagnostics,null, null, fileObjs); 
		if (!tareaCompilacion.call()) {  // carry out the compilation 
			System.err.println("Compilation failed"); 

			for (Diagnostic d : diagnostics.getDiagnostics()) 
				System.err.println(d); 	
		}else{
			System.out.print("Compilation successfully ");
			if (aOkEjecucion){
				
				
				HebraEjecucion hebra = 	new HebraEjecucion (aDirectorioFichero);
				hebra.start();
				
			}
//			StringBuffer comando = new StringBuffer();
//			comando.append("java ")
//			.append("-classpath ").append(aDirectorioFichero.getParent())
//			.append(" ").append(OperacionesFicheros.getNombreSinExtension(aDirectorioFichero));	  
//
//
//
////			se ejecuta el comando
//
//			//Runtime lrRun = Runtime.getRuntime();
//			if ( objLogger.isDebugEnabled() )
//	            objLogger.debug("Compilacion Java:  " +"cmd /c start "+comando.toString() );
//
//			
//
//
//			try{
//
//
//				Runtime rt = Runtime.getRuntime();
//				// Process p = rt.exec("cmd /c start "+comando.toString());
//				rt.exec("cmd /c start "+comando.toString());
//			} catch (IOException e) {
//				// TODO Bloque catch generado automticamente
//				Mensajes.mensajeDetalles("Error al lanzar la consola.", e);
//
//			}
//			
//			}
			
//			Class<?> outputClassObject;
//			try {
//				outputClassObject = Class.forName(aDirectorioFichero.toString());
//				Class[] fpl = { String[].class };
//				java.lang.reflect.Method m;
//
//				try {
//					m = outputClassObject.getMethod( "main", fpl );
//					if (m!=null){
//						StringBuffer comando = new StringBuffer();
//						comando.append("java ")
//						.append("-classpath ").append(aDirectorioFichero.getAbsolutePath())
//						.append(" ").append(aDirectorioFichero);	  
//
//
//
////						se ejecuta el comando
//
//						//Runtime lrRun = Runtime.getRuntime();
//
//
//						try{
//
//
//							Runtime rt = Runtime.getRuntime();
//							// Process p = rt.exec("cmd /c start "+comando.toString());
//							rt.exec("cmd /c start "+comando.toString());
//						} catch (IOException e) {
//							// TODO Bloque catch generado automticamente
//							Mensajes.mensajeDetalles("Error al lanzar la consola.", e);
//
//						}
//					}
//				} catch (SecurityException e1) {
//					// TODO Bloque catch generado automticamente
//					e1.printStackTrace();
//				} catch (NoSuchMethodException e1) {
//					// TODO Bloque catch generado automticamente
//					e1.printStackTrace();
//				}
//
//			} catch (ClassNotFoundException e2) {
//				// TODO Bloque catch generado automticamente
//				e2.printStackTrace();
//			}
			



		}
	}



	/** sustituyeArgumentos 
	 *
	 * 	<p>Dado un mensaje con argumentos %0, %1, ... , %9 (mx 10) y un array con dichos argumentos
	 * 	devuelve dicho mensaje con los argumentos sustituidos</p>
	 *
	 *  En caso de faltar se sustituye con '?'
	 *
	 * @param 	asCad		La cadena cuyos %i se quieren sustituir
	 * @param 	aasArgs		Array de argumentos
	 * @return	La cadena sustituyendo los argumentos correspondientes
	 *
	 *  Ejemplos: 	Para:
	 *						"Introduzca un valor entre %0 y %1." y {"45", "100"}
	 *				Devolvera:
	 *						"Introduzca un valor entre 45 y 100."
	 *				Para:
	 *						"Introduzca un valor entre %1 y %2." y {"45", "100"}
	 *				Devolvera:
	 *						"Introduzca un valor entre 100 y ?."
	 *				Para:
	 *						"Introduzca un valor entre %1 y %0." y {"45", "100"}
	 *				Devolvera:
	 *						"Introduzca un valor entre 100 y 45."
	 *@author Parras
	 */
	
	
	public static String sustituyeArgs(String asCad, String aasArgs[])
	{
		int liNumArg;
		String lsPalabra;
		String lsProxPalabra;
		char lcSgte;
		
		String lsMensaje = new String("");
		
		// Troceamos la frase y buscamos %i
		StringTokenizer st = new StringTokenizer(asCad);
	
		while (st.hasMoreTokens())
		{			
			lsProxPalabra = st.nextToken();
		
			// Hemos encontrado un %i
			if (lsProxPalabra.startsWith("%"))
			{	
				liNumArg = lsProxPalabra.charAt(1) - '0'; // Para pasar de char a int

				if (liNumArg < aasArgs.length) // Si este argumento existe, lo sustituimos
				{
					lsPalabra = aasArgs[liNumArg];

					// Si hemos encontrado un "%i." aadimos el "."
					try{
						lcSgte = lsProxPalabra.charAt(2);
						lsPalabra = lsPalabra + lcSgte;
					}
					catch (IndexOutOfBoundsException e)
					{
						// No necesitamos hacer nada
					}
				}
				else // Si no existe, lo sustituimos por un '?'
				{
					lsPalabra = "?";
				}
			}
			// Es una palabra normal
			else
			{
				lsPalabra = lsProxPalabra;
			}
			
			// Componemos la frase
			lsMensaje = lsMensaje + lsPalabra + " ";
		}
		
		return lsMensaje.trim();
	}


	/**
	 * <P>
	 * Recorre la cadena pasada como argumento sustituyendo todas las
	 * apariencias de la cadena asCadOld por la cadena asCadNew. Al final
	 * devuelve la cadena modificada.
	 * </P>
	 * 
	 * @param asCadena
	 *            La cadena que se va a recorrer.
	 * @param asCadOld
	 *            La cadena que se va a buscar.
	 * @param asCadNew
	 *            La cadena nueva que se va a sustituir.
	 * 
	 * @return String La cadena sustituida.
	 */

	public static String modificaCadena(String asCadena, String asCadOld, String asCadNew){

		String lsCadenaCorregida = "";
		int liLongitud = asCadena.length();
		int liLongCadOld = asCadOld.length();
		String lsTrozo = "";
		String lsCaracter = "";
		for (int i = 0; i < liLongitud; i++) 
		{
			if (i+liLongCadOld <= liLongitud)
			{
				lsTrozo = asCadena.substring(i, i+liLongCadOld);
				lsCaracter = asCadena.substring(i, i+1);
				if (lsTrozo.equals(asCadOld))
				{
					lsCadenaCorregida= lsCadenaCorregida + asCadNew;
					i += liLongCadOld-1;
				}
				else
					lsCadenaCorregida = lsCadenaCorregida + lsCaracter;

			}
			else
			{
				lsCadenaCorregida = lsCadenaCorregida + asCadena.substring(i, liLongitud);
				i = liLongitud;
			}                }

		return lsCadenaCorregida;

	}
	
	/**
	 * addNodos Pasado un DefaultMutableTreeNode y un directorio nos enganchan
	 * en nuestro rbol los que esten en dicho directorio.
	 * 
	 * @param nodo
	 *            the nodo
	 * @param dir
	 *            the dir
	 * 
	 * @return the default mutable tree node
	 */

	public static  DefaultMutableTreeNode addNodos(DefaultMutableTreeNode nodo, File dir) {

		String curPath = dir.getPath();
		DefaultMutableTreeNode curDir = new DefaultMutableTreeNode(new Nodo (dir,nodo));
		//Guardar una lista de paquetes de para nuestro jlist

		if (nodo != null) { // Si el directorio raiz es nulo
			nodo.add(curDir);
		}
		Vector<String> ol = new Vector <String>();    
		String[] tmp = dir.list();
		if (tmp!=null){
			for (int i = 0; i < tmp.length; i++)
				ol.addElement(tmp[i]);
			Collections.sort(ol, String.CASE_INSENSITIVE_ORDER);
			File f;
			Vector<Nodo> files = new Vector<Nodo>();
			// Miramos si es carpeta o fichero
			for (int i = 0; i < ol.size(); i++) {
				String thisObject = (String) ol.elementAt(i);
				String newPath;
				if (curPath.equals("."))
					newPath = thisObject;
				else
					newPath = curPath + File.separator + thisObject;
				if ((f = new File(newPath)).isDirectory())
					addNodos(curDir, f);
				else{
					if (ArbolFicheros.acceptarExt(new File (thisObject))){
						files.addElement(new Nodo (
								new File (curPath + File.separator + thisObject),false,nodo));
						//System.out.println ("<******** "+curPath + File.separator + thisObject );
					}
				}

			}
			//Los ficheros que nos quedan
			for (int fnum = 0; fnum < files.size(); fnum++){
				curDir.add(new DefaultMutableTreeNode(new Nodo (new File (curPath + File.separator +files.elementAt(fnum)),false,nodo)));
				//System.out.println ("---> "+curPath + File.separator +files.elementAt(fnum) );
			}
		}
		return curDir;
	}
	
	/**
	 * Clase que nos devuelve solo la extensin que le pasamos al contructor.
	 * 
	 * @author Parras
	 */
	static class MiFiltro implements FileFilter{
		
		/** The is extension. */
		String isExtension;
		
		/**
		 * nos devuelve solo la extensin que le pasamos al contructor.
		 * 
		 * @param extension
		 *            the extension
		 */
		MiFiltro (String extension) {
			isExtension = extension;
		}

		/* (non-Javadoc)
		 * @see java.io.FileFilter#accept(java.io.File)
		 */
		public boolean accept(File pathname) {
			return pathname.toString().endsWith(isExtension);
		}

	}
	
	
 
	/**
	 * Convertir ahtml.
	 * <p>
	 * mtodo para convertir una cadena de texto a un TAG de HTML <a>...</a>.
	 * </p>
	 * 
	 * @param asCadena
	 *            the as cadena
	 * 
	 * @return the string Creado : Parras, 13-oct-2009
	 */
	public static String convertirAHTML(String asCadena) {

		String lsCadena = "";
		String lsSubCad1, lsSubCad2, lsSubCad3;
		int liSubIndice = 0;
		int liSuperIndice = 0;
		int liIndice = 0;
		int liIndice2 = 0;

		int liPosFinalTagsCabecera = 0;
		int liPosInicioTagsFinal = 0;

		liPosFinalTagsCabecera = asCadena.toLowerCase().indexOf("<p>");
		liPosInicioTagsFinal = asCadena.toLowerCase().lastIndexOf("</p>");
		if (liPosFinalTagsCabecera < liPosInicioTagsFinal)
			asCadena = asCadena.substring(liPosFinalTagsCabecera + 3,
					liPosInicioTagsFinal);

		liIndice = asCadena.toLowerCase().indexOf("http://");

		// Mientras sigo encontrando "http://" continuo ...
		while (liIndice > 0) {

			// Comprobar si el "http://" que he encontrado esta entre
			// "<a href=" y "</a>".
			liSubIndice = asCadena.toLowerCase().indexOf("<a href=", liIndice2);
			liSuperIndice = asCadena.toLowerCase().indexOf("</a>", liSubIndice);

			if ((liSubIndice < liIndice) && (liIndice < liSuperIndice)) {
				lsCadena = lsCadena
						+ asCadena.substring(liIndice2, liSuperIndice);

				// Actualizo liIndice2, para que continue mirando el resto de la
				// cadena
				liIndice2 = liSuperIndice;
			} else {
				// Texto hasta donde est el http://
				lsSubCad1 = asCadena.substring(liIndice2, liIndice);

				liIndice2 = asCadena.indexOf(" ", liIndice + 1);

				// En lsSubCad2 estar la cadena con "http://www._______.___"
				lsSubCad2 = asCadena.substring(liIndice, liIndice2);

				// Tengo que aadir un espacio &nbsp; al final del tag </a> para
				// que si se inserta
				// mas texto tras un enlace no lo considere parte del
				// hipervinculo
				lsSubCad2 = "<a href='" + lsSubCad2 + "'>" + lsSubCad2
						+ "</a>&nbsp;";

				lsCadena = lsCadena + lsSubCad1 + lsSubCad2;
			}
			liIndice = asCadena.toLowerCase().indexOf("http://", liIndice2);
		}

		// En lsSubCad3 est lo que hay a la derecha del http://...
		lsSubCad3 = asCadena.substring(liIndice2);

		lsCadena = lsCadena + lsSubCad3;

		return lsCadena;
	}

	//
	/**
	 * Quitar tags html.
	 * <p>
	 * Filtrar una cadena HTML para quitarle los tags del principio y del final
	 * </p>
	 * 
	 * @param asCadena
	 *            the as cadena
	 * 
	 * @return the string Creado : Parras, 13-oct-2009
	 */
	public static String quitarTagsHTML(String asCadena) {

		String lsCadena = asCadena;
		int liPosFinalTagsCabecera = 0;
		int liPosInicioTagsFinal = 0;

		liPosFinalTagsCabecera = asCadena.toLowerCase().indexOf("<body>");
		liPosInicioTagsFinal = asCadena.toLowerCase().indexOf("</body>");
		if (liPosFinalTagsCabecera < liPosInicioTagsFinal)
			lsCadena = asCadena.substring(liPosFinalTagsCabecera + 6,
					liPosInicioTagsFinal);
		// System.out.println("CADENA FILTRADA=" + lsCadena);
		return lsCadena;
	}
	
	
	/**
	 * Filtra por Extensiones
	 */
	public class ExtensionFilter implements FilenameFilter {
		  
  		/** The extension. */
  		private String extension;
		  
  		/**
		 * Constructor extension filter.
		 * 
		 * Creado : Parras, 21-feb-2010
		 * 
		 * @param extension
		 *            the extension
		 */
  		public ExtensionFilter( String extension ) {
		    this.extension = extension;             
		  }
		  
		  /* (non-Javadoc)
  		 * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
  		 */
  		public boolean accept(File dir, String name) {
		    return (name.endsWith(extension));
		  }
		}


}
